#================================================================================
#    $Revision: 1.1 $
#    $Source: D:/CVS/cvsrepo/thuban/Extensions/precisionFarming/applicationAnpasser.py,v $
#    $Id: applicationAnpasser.py,v 1.1 2004/09/13 13:54:09 orahn Exp $
#================================================================================
import os

from customSaveAndLoad import customSessionLoader,customSessionSaver

from Thuban.Model.load import LoadCancelled
from Thuban.Model.save import save_session
from Thuban.Model.layer import RasterLayer

anpasserObjekt = None

class applicationAnpasser:
    """
    Klasse zum nachtraeglichen Ueberschreiben der SaveSession-Methode der Application Klasse,
    um zu verhindern, dass es zu Fehlern kommt, wenn eine Session mit Layer ohne Datengrundlage (Shapefile od. DB) gespeichert werden soll.
    Ein solches Layer wird jetzt uebersprungen.

    Durch diese Art des Ueberschreibens, muss die Applikation nicht gepatcht werden.
    
    Klasse ist ein Singleton (soweit das in Python moeglich ist...)
    """
    def __init__(self):
        self.application = None
        self.istAngepasst = False

    def passeAn(self, app):
        if self.istAngepasst == True:
            return
        else:
            self.application = app
            #self.application.SaveSession = custom_save_session
            self.application.OpenSession = OpenSession
            
    def getApplicationAnpasser():
        global anpasserObjekt
        if ( anpasserObjekt == None ):
            anpasserObjekt = applicationAnpasser()
        return anpasserObjekt
        

    getApplicationAnpasser = staticmethod( getApplicationAnpasser )
    
## ----------------------------------------------


def OpenSession(filename, db_connection_callback=None):
    """Open the session in the file named filename"""
    # Make sure we deal with an absolute pathname. Otherwise we can
    # get problems when saving because the saving code expects an
    # absolute directory name

    filename = os.path.abspath(filename)
    if db_connection_callback is None:
        db_connection_callback = applicationAnpasser.getApplicationAnpasser().application.run_db_param_dialog
    try:
        session = custom_load_session(filename, db_connection_callback)
    except LoadCancelled:
        return
    session.SetFilename(filename)
    session.UnsetModified()
    applicationAnpasser.getApplicationAnpasser().application.SetSession(session)

    for map in session.Maps():
        for layer in map.Layers():
            if isinstance(layer, RasterLayer) \
                and not Thuban.Model.resource.has_gdal_support():
                msg = _("The current session contains Image layers,\n"
                        "but the GDAL library is not available to "
                        "draw them.")
                dlg = wx.wxMessageDialog(None,
                                         msg,
                                         _("Library not available"),
                                         wx.wxOK | wx.wxICON_INFORMATION)
                print msg
                dlg.ShowModal()
                dlg.Destroy()
                break
                
def custom_load_session(filename, db_connection_callback = None):
    """Load a Thuban session from the file object file

    The db_connection_callback, if given should be a callable object
    that can be called like this:
       db_connection_callback(params, message)

    where params is a dictionary containing the known connection
    parameters and message is a string with a message why the connection
    failed. db_connection_callback should return a new dictionary with
    corrected and perhaps additional parameters like a password or None
    to indicate that the user cancelled.
    """

    handler = customSessionLoader(db_connection_callback)
    handler.read(filename)

    session = handler.theSession
    # Newly loaded session aren't modified
    session.UnsetModified()

    handler.Destroy()

    return session
    
def custom_save_session(session, file, saver_class = None):
    """
    Methode die die save_session mit einer SessionSaver Klasse aufruft und somit den customSessionSaver ins Spiel bringt.
    """
    if ( saver_class == None ):
        save_session(session, file, customSessionSaver)
    else:
        save_session(session, file, saver_class)

    