import math
import random

# punkt importieren
from utilities import *

from fehler import *
from fehlerhaftesObjekt import *

# schleifen beschleunigen
try:
    from psyco.classes import __metaclass__
except:
    pass


class clusterer(potentiellFehlerhaftesObjekt):
    def __init__( self, werte, swFaktor = None ):
        potentiellFehlerhaftesObjekt.__init__(self)

        self.debug = False
        self.staerkeDerFuzzyfizierung = 2
        self.schwellWert = 0.000005
        self.mengeWerte = len(werte[0])

        self.schwellenWertFaktor = .004
        if ( swFaktor != None ):
            self.schwellenWertFaktor = swFaktor

        self.mins = []
        self.maxs = [] 

        for i in range( len(werte)):
            for j in range( len(werte[i])):
                if len(self.mins) < i+1:
                    self.mins.append( werte[i][j] )
                elif self.mins[i] > werte[i][j]:
                    self.mins[i] = werte[i][j]
                if len(self.maxs) < i+1:
                    self.maxs.append( werte[i][j] )
                elif self.maxs[i] < werte[i][j]:
                    self.maxs[i] = werte[i][j]
                
        for i in range( len(werte)):
            werte[i] = self._normiereFeld( werte[i], self.mins[i], self.maxs[i] )
            if self.fehlerIstAufgetreten():
                print "- ein Fehler ist aufgetreten:", self.getFehler()
                return

        self.rohWerte = werte
        
        self.setzeClusterAnzahl(2)
        
    def getStaerkeDerFuzzyfizierung(self):
        return self.staerkeDerFuzzyfizierung
        
    def bildeClusterMitGuterClusterAnzahl( self ):
        K = 0
        K_alt = 0
        if self.fehlerIstAufgetreten():
            print "- ein Fehler ist aufgetreten:", self.getFehler()
            return
        guteClusterZahl = min(1, self.mengeWerte)
        print "- suche geeignete Clusteranzahl"
        for i in range( min(1, self.mengeWerte), min(20, self.mengeWerte) ):
            print "- teste", i, K
            K_alt = K
            self.setzeClusterAnzahl( i )
            K = self.bildeCluster()
            if self.fehlerIstAufgetreten():
                print "- ein Fehler ist aufgetreten:", self.getFehler()
                return
            if self.debug == True:
                print K, K_alt
            if i > 1:
                guteClusterZahl = i-1
            else:
                guteClusterZahl = i

            if math.fabs( math.fabs(K) - math.fabs(K_alt) ) < self.mengeWerte * self.schwellenWertFaktor and K_alt != 0:
                print K, K_alt
                break
        print "- gute Anzahl gefunden:", guteClusterZahl
        print "- starte Clusterbildung mit", guteClusterZahl, "Clustern"
        self.setzeClusterAnzahl( guteClusterZahl )
        self.bildeCluster( False )
   
    def setzeClusterAnzahl( self, mengeCluster ):
        self.mengeCluster = mengeCluster
        self.clusterZentren = []
        nullkoords =[]
        for i in range( len(self.rohWerte) ):
            nullkoords.append(0)
        
        for i in range( self.mengeCluster ):
            neuerPunkt = clusterPunkt( nullkoords, i )
            neuerPunkt.normiert = True
            self.clusterZentren.append( neuerPunkt )
            
        self.punktefeld = []
        for i in range(  self.mengeWerte  ):
            koords = []
            for j in range( len(self.rohWerte)):
                koords.append( self.rohWerte[j][i] )
            neuerPunkt = clusterPunkt( koords, -1, self.mengeCluster )
            neuerPunkt.normiert = True
            self.punktefeld.append( neuerPunkt )
    
    def bildeCluster( self, berechneK = True ):
        durchgaenge = 0
     # initiales, zufaelliges Zuweisen der Clusterzentren
        
        # initialisieren des zufallsgenerators mit der systemzeit
        random.seed()
        punktIndicesDerClusterzentren = []
        
        for i in range( self.mengeCluster ):
            for j in range( self.punktefeld[0].dimension ):
                self.clusterZentren[i].koord[j] = random.random()
        
        schwellWertFuerPunktemenge = self.schwellWert * len( self.punktefeld )
     # while sich die quadrierten Abstaende noch stark aendern
        aktuellerGewichteterGesamtAbstand = 0
        letzterGewichteterGesamtAbstand = schwellWertFuerPunktemenge * 2.
        while math.fabs( aktuellerGewichteterGesamtAbstand - letzterGewichteterGesamtAbstand ) > schwellWertFuerPunktemenge:
            if self.debug == True:
                print durchgaenge, aktuellerGewichteterGesamtAbstand, letzterGewichteterGesamtAbstand, schwellWertFuerPunktemenge
            durchgaenge += 1
            # ermitteln der Gewichte zu den Clusterzentren fuer jeden punkt
            letzterGewichteterGesamtAbstand = aktuellerGewichteterGesamtAbstand
            aktuellerGewichteterGesamtAbstand = 0.
            
            for i in range( len(self.punktefeld)):
                for l in range( self.mengeCluster ):
                    # summe von 1 bis self.mengeCluster aus(   abstand( punkt[i], clusterzentr[l] )^2  / abstand( punkt[i], clusterzentr[j] )^2 )
                    komischeSummeUeberAlleCluster = 0.
                    neuesGewicht = -1.
                    
                    for j in range( self.mengeCluster ):
                        if self.punktefeld[i].abstandZu( self.clusterZentren[j] ) != 0:
                            komischeSummeUeberAlleCluster += ( math.pow(self.punktefeld[i].abstandZu( self.clusterZentren[l] ),2) / math.pow(self.punktefeld[i].abstandZu( self.clusterZentren[j] ),2) )

                        # wenn ein Punkt keinen abstand zu einem der zentren hat...
                        elif self.punktefeld[i].abstandZu( self.clusterZentren[l] ) == 0:
                            #... geht das betreffende zentrum mit dem max. gewicht (1) ein ...
                            neuesGewicht = 1.
                        else:
                            # ... und alle anderen erhalten das min. gewicht (0).
                            neuesGewicht = 0.
                        
                    # (m-1)-te Wurzel aus der Summe
                    if neuesGewicht < 0:
                        mMinusErsteWurzel = math.pow( komischeSummeUeberAlleCluster, (1.0/(self.staerkeDerFuzzyfizierung - 1.0)) )
                        neuesGewicht = 1.0/mMinusErsteWurzel
                        
                    self.punktefeld[i].SetZugehoerigkeit( l, neuesGewicht )
                    aktuellerGewichteterGesamtAbstand += ( math.pow(self.punktefeld[i].abstandZu( self.clusterZentren[l] ),2) * math.pow( neuesGewicht, self.staerkeDerFuzzyfizierung ) )
                
                
            
     # ermitteln der neuen Clusterzentren (Schwerpunkte der zugehoerigkeiten)
            for l in range( self.mengeCluster ):
                summeDerGewichte = 0
                summeGewichteteKoord = []
                for i in range(self.clusterZentren[l].dimension):
                    summeGewichteteKoord.append( 0. )
                for i in self.punktefeld:
                    summeDerGewichte += i.GetZugehoerigkeit( l )
                    for j in range(self.clusterZentren[l].dimension):
                        summeGewichteteKoord[j] += i.koord[j] * i.GetZugehoerigkeit( l )

                for i in range(self.clusterZentren[l].dimension):
                    self.clusterZentren[l].koord[i] = summeGewichteteKoord[i] / summeDerGewichte

    # berechne K als Mass fuer die Guete der aktuellen Clusteranzahl
        if berechneK == True:
            s_quer = clusterPunkt( self.punktefeld[0].koord, -1, self.mengeCluster )

            for i in range( 1, len(self.punktefeld) ):
                for j in range(self.punktefeld[i].dimension):
                    s_quer.koord[j] += self.punktefeld[i].koord[j]
            
            for j in range(s_quer.dimension):
                s_quer.koord[j] /= self.mengeWerte            
            
            K = .0
            for l in range( self.mengeCluster ):
                for i in self.punktefeld:
                    abst_Differenz = math.pow( i.abstandZu(self.clusterZentren[l]), 2) - s_quer.abstandZu(self.clusterZentren[l])
                    K += ( math.pow( i.GetZugehoerigkeit( l ), self.staerkeDerFuzzyfizierung ) * abst_Differenz )
                    
            return K
        else:
            return 0
    
    def getGeclustertesPunktefeld( self ):
    
        ranges = []
        
        for i in range( min( len(self.mins), len(self.maxs) ) ):
            ranges.append( self.maxs[i] - self.mins[i] )

        
        for i in self.punktefeld:
            if i.normiert == True:
                i.normiert = False
                for j in range(i.dimension):
                    i.koord[j] = 1.0 * i.koord[j] * ranges[j] + self.mins[j]
            
        return self.punktefeld
        
    def getClusterzentren( self ):
        ranges = []
        
        for i in range( min( len(self.mins), len(self.maxs) ) ):
            ranges.append( self.maxs[i] - self.mins[i] )
        
        for i in self.clusterZentren:
            if i.normiert == True:
                for j in range(i.dimension):
                    i.koord[j] = i.koord[j] * ranges[j] + self.mins[j]
    
        return self.clusterZentren
                
    def _normiereFeld( self, feld, minWert, maxWert ):
        Range = maxWert - minWert
        neuerWert = 0
        letzterWert = 0
        
        if Range == 0:
            self.setFehler( code = FEHLER_MIN_WERT_GLEICH_MAX_WERT )
            return None
        
        neuesFeld = []
        for i in feld:
            neuerWert = float((1.0 * i - minWert)/Range)
            neuesFeld.append( neuerWert )
            letzterWert = i
        
        print "wert:", letzterWert
        print "min/max:", minWert,",", maxWert
        print "Range:", Range

        return neuesFeld
