from Thuban.UI.command import registry, Command, ToolCommand
from Thuban.UI.viewport import Tool, RectTool
from wxPython.wx import *

from Thuban import _
from Thuban.Model.data import *
from Thuban.Model.map import Map
from Thuban.Model.color import Color
from Thuban.UI.mainwindow import *
from Thuban.Model.classification import ClassGroupSingleton, ClassGroupProperties

from diagrammDialog import *
from utilities import *
from clusterer import *
from diagram import *
from data_fake import *

from customLayer import *
from applicationAnpasser import *

from Thuban.Model.table import MemoryTable, \
     FIELDTYPE_DOUBLE, FIELDTYPE_INT, FIELDTYPE_STRING

# ----------------------------------------------------------

class ClusteringTool(RectTool):

    def __init__(self, view, context, findePunktLayer):
        RectTool.__init__(self, view)
        self.context = context
        self.startX = 0
        self.startY = 0
        
        self.map = self.context.mainwindow.canvas.Map()
        self.layer = None
        #self.idLayer = None
        self.identified = None
        
        self.bboxToIdLayer = {}
        
        self.clusterMacher = None
        self.mapNummerZuShapeId = None
        self.attribute = None
        
        self._findePunktLayer = findePunktLayer
        self.layerMitPunktdaten = None
        
        self.diagramme = []
        
        applicationAnpasser.getApplicationAnpasser().passeAn(context.application)
        
    def RemoveLayer( self, bboxLayer ):
        try:
            if ( bboxLayer != None ):
                self.map.RemoveLayer( bboxLayer )
            if ( self.bboxToIdLayer.has_key(bboxLayer.getId()) ):
                self.map.RemoveLayer( self.bboxToIdLayer[bboxLayer.getId()] )
                
                newDict = {}
                for key in self.bboxToIdLayer.keys():
                    if key != bboxLayer.getId():
                        newDict[key] = self.bboxToIdLayer[key]
                self.bboxToIdLayer = newDict
        except:
            print "das layer war wohl schon weg!"
        
        
    def Name(self):
        return "ClusteringWerkzeug"
        
    def identifizierePunkte( self, index, indexeZugehoerigerPunkte, farbe, bboxLayer ):
        print "ClusteringTool.identifizierePunkte"
        if ( index in self.identified ):
            print "wurde bereits identifiziert"
            return
        else:
            self.identified.append( index )
        
        storageObjekt = None
        
        if ( not self.bboxToIdLayer.has_key(bboxLayer) ):
            attrTable = self.layerMitPunktdaten.ShapeStore().Table()
            cols = attrTable.Columns()
            colMap = {}
            
            for col in cols:
                #print col.name
                colMap[ col.name ] = col

            storageObjekt = MemoryShapeStore()
            storageObjekt.bbox = self.layer.BoundingBox()

            attrString = repr( self.attribute )
            attrString.replace( "'", "" )
            titel = "Identifierung von Punkten zu Clustern (" + attrString + ")"
            
            tableHead = []
            tableHead.append( ("groesste Zugehoerigk. zu Cluster", FIELDTYPE_INT)  )
            
            for attribut in self.attribute:
                tableHead.append( (attribut,colMap[attribut].type)  )
               
            storageObjekt.setTable( MemoryTable(tableHead,[]) )
            storageObjekt.setTitle( titel )
        else:
            storageObjekt = self.bboxToIdLayer[bboxLayer].ShapeStore()
            
        for punktIndex in indexeZugehoerigerPunkte.keys():
            punktObjekt = indexeZugehoerigerPunkte[punktIndex]
            shape = self.layerMitPunktdaten.Shape( self.mapNummerZuShapeId[ punktIndex ] ) 

            
            x, y = shape.Points()[0][0]
            #print x, y
            storageObjekt.addPoint( x, y )
            attrData = []
            attrData.append( punktObjekt.GetPrimaereZugehoerigkeit() )
            
            for attr in punktObjekt.koord:
                attrData.append( attr )
                
            storageObjekt.appendAttributeData( attrData )
            
        if ( not self.bboxToIdLayer.has_key(bboxLayer) ):
            idLayer = customLayer( _(titel), storageObjekt, typenMap.getIdLayer() )
            idLayer.SetClassificationColumn( storageObjekt.Table().Column(0).name )
        else:
            idLayer = self.bboxToIdLayer[bboxLayer]
        
        
        classif = idLayer.GetClassification()
        props = ClassGroupProperties()
        props.SetFill( Color( float(farbe.Red()/255.0), float(farbe.Green()/255.0), float(farbe.Blue()/255.0) ) )
        classif.AppendGroup( ClassGroupSingleton( index, props, "Cluster Nr."+str(index) ) )
        #idLayer.SetClassification(classif)
        
        if ( not self.bboxToIdLayer.has_key(bboxLayer) ):
            self.bboxToIdLayer[bboxLayer] = idLayer   
            self.context.session.AddShapeStore( storageObjekt )
            self.map.AddLayer(self.bboxToIdLayer[bboxLayer])

        self.context.mainwindow.canvas.full_redraw()

    def MouseDown(self, event):
        RectTool.MouseDown(self, event)
        self.startX, self.startY = self.view.win_to_proj(*self.current)

    def MouseUp(self, event):
        #self.RemoveLayer()
        self.idLayer = None
        self.identified = []
        
        RectTool.MouseUp(self, event)
        x, y = self.view.win_to_proj(*self.current)
        bbox = ( min(x,self.startX), min(y,self.startY), max(x,self.startX), max(y,self.startY) )
        #print bbox
        main_window = self.context.mainwindow
        map = main_window.canvas.Map()
        #print x, y
        if map.HasLayers() == True:
            nummerlayerMitPunktdaten = self._findePunktLayer(self.context)
    
            if nummerlayerMitPunktdaten < 0:
                main_window.RunMessageBox(_('missing base data layer'), _('Please add a layer consisting of point data, first'))
                return
                
            self.layerMitPunktdaten = map.layers[ nummerlayerMitPunktdaten ]
            
            attrTable = self.layerMitPunktdaten.ShapeStore().Table()
            cols = self.layerMitPunktdaten.ShapeStore().Table().Columns()
            colNames = []
            
            for i in cols:
                if i.type == FIELDTYPE_INT or i.type == FIELDTYPE_DOUBLE:
                    colNames.append( i.name )
                
            diagram_titel = _("Angaben zum Clustering")
            werteSindDiskret = False
    
            v_dialog = cluster_dialog( main_window, colNames, diagram_titel, "Hinweis:\nJe kleiner der Schwellenwert Faktor ist, desto cluster-freudiger wird die Analyse" )
            userEingabe = v_dialog.RunDialog()
            if userEingabe == None:
                return
            
            if (attrTable.HasColumn( userEingabe["xattr"] )==True and \
                attrTable.HasColumn( userEingabe["yattr"] )==True):
                aktCol = attrTable.Column( userEingabe["xattr"] )
                if aktCol.type != FIELDTYPE_INT and aktCol.type != FIELDTYPE_DOUBLE:
                    werteSindDiskret = True
                aktCol = attrTable.Column( userEingabe["yattr"] )
                if aktCol.type != FIELDTYPE_INT and aktCol.type != FIELDTYPE_DOUBLE:
                    werteSindDiskret = True
            
            #while (attrTable.HasColumn( userEingabe["xattr"] )==False or attrTable.HasColumn( userEingabe["yattr"] )==False) or userEingabe["numCluster"].isdigit()==False or werteSindDiskret == True:
            while (attrTable.HasColumn( userEingabe["xattr"] )==False or \
                   attrTable.HasColumn( userEingabe["yattr"] )==False) or \
                   werteSindDiskret == True or \
                   not istZahl(userEingabe["swf"]):
                if attrTable.HasColumn( userEingabe["xattr"] )==False:
                    v_dialog = cluster_dialog( main_window, colNames, diagram_titel, _("das X Attribut existiert nicht") )
                elif attrTable.HasColumn( userEingabe["yattr"] )==False:
                    v_dialog = cluster_dialog( main_window, colNames, diagram_titel, _("das Y Attribut existiert nicht") )
                elif (not istZahl(userEingabe["swf"])):
                    v_dialog = cluster_dialog( main_window, colNames, diagram_titel, _("Der Schwellenwert Faktor muss eine Zahl sein!") )
                else:
                    if attrTable.Column( userEingabe["xattr"] ).type != FIELDTYPE_INT and attrTable.Column( userEingabe["xattr"] ).type != FIELDTYPE_DOUBLE:
                        werteSindDiskret = True
                    elif attrTable.Column( userEingabe["yattr"] ).type != FIELDTYPE_INT and attrTable.Column( userEingabe["yattr"] ).type != FIELDTYPE_DOUBLE:
                        werteSindDiskret = True
                    else:
                        werteSindDiskret = False
                
                userEingabe = v_dialog.RunDialog()
                if userEingabe == None:
                    return
    
            # betroffene Punkte ermitteln                
            punkteShapefeld = self.layerMitPunktdaten.ShapesInRegion(bbox)
            
            self.punktefeld = []
            
            swf = float(userEingabe["swf"])
            swf /= 1000.

            for i in punkteShapefeld:
                Px, Py = i.Points()[0][0]
                # Thuban ist zu ungenau, zweites filtern noetig
                if Px >= bbox[0] and Px <= bbox[2] and Py >= bbox[1] and Py <= bbox[3]:
                    self.punktefeld.append( punkt( [Px, Py], i.ShapeID() ) )
            
            if len( self.punktefeld ) <= 0:
                print "- keine Punkte im gewaehlten Bereich"
                main_window.RunMessageBox(_('keine Punkte'), _('Keine Punkte im gewaehlten Bereich'))
                return

            # box anzeigen
            storageObjekt = MemoryShapeStore()
            storageObjekt.bbox = bbox
            
            titel = "Clustering fuer "+ str( len(self.punktefeld) ) + " Punkte"
            
            storageObjekt.setTable( MemoryTable([("Bezeichnung", FIELDTYPE_STRING)],[]) )
            storageObjekt.setTitle( titel )
            
            # obere Linie
            storageObjekt.addLine( [bbox[0], bbox[2]], [bbox[3],bbox[3]] )
            storageObjekt.appendAttributeData( ["oben"] )
            # rechte Linie
            storageObjekt.addLine( [bbox[2], bbox[2]], [bbox[1],bbox[3]] )
            storageObjekt.appendAttributeData( ["rechts"] )
            # untere Linie
            storageObjekt.addLine( [bbox[0], bbox[2]], [bbox[1],bbox[1]] )
            storageObjekt.appendAttributeData( ["unten"] )
            # linke Linie
            storageObjekt.addLine( [bbox[0], bbox[0]], [bbox[1],bbox[3]] )
            storageObjekt.appendAttributeData( ["links"] )
            
            
            
    
            self.layer = customLayer( _(titel), storageObjekt)

            self.context.session.AddShapeStore( storageObjekt )
            self.map.AddLayer(self.layer)
            self.map.MoveLayerToBottom(self.layer)
            self.context.mainwindow.canvas.full_redraw()

            # Attributdaten dieser Punkte adaptieren
            #x_attr = []
            #y_attr = []
            
            werte = []
            self.attribute = [ userEingabe["xattr"], userEingabe["yattr"] ]
            diagrammTitel = "Cluster fuer "+userEingabe["xattr"]+", "+userEingabe["yattr"]
            
            if userEingabe.has_key("optattr") == True:
                for i in userEingabe["optattr"]:
                    diagrammTitel = diagrammTitel + ", " + i
                    self.attribute.append( i )
            
            for j in range( len(self.attribute)):
                werte.append([])

            
            self.mapNummerZuShapeId = {}
            
            for i in range( len(self.punktefeld)):
                self.mapNummerZuShapeId[i] = self.punktefeld[i].index
                for j in range( len(self.attribute)):
                    werte[j].append( attrTable.ReadValue( self.punktefeld[i].index, self.attribute[j] ) )
            
            self.clusterMacher = clusterer( werte, swf )

            if self.clusterMacher.fehler == None:
                self.clusterMacher.bildeClusterMitGuterClusterAnzahl()
            else:
                main_window.RunMessageBox(_('Fehler beim Clustern'), _(str(self.clusterMacher.fehler)))
                print "- Abbruch:", self.clusterMacher.fehler
                self.map.RemoveLayer(self.layer)
                return
            
            diagramMaler = punkt_diagramZeichner( main_window, _(diagrammTitel), ((self.clusterMacher.mins[0],self.clusterMacher.maxs[0]), (self.clusterMacher.mins[1],self.clusterMacher.maxs[1])), self.clusterMacher.getGeclustertesPunktefeld(), self.clusterMacher.getClusterzentren(), [userEingabe["xattr"],userEingabe["yattr"]], self, fuzzy = self.clusterMacher.getStaerkeDerFuzzyfizierung()  )
            diagramMaler.RunDialog()
            self.diagramme.append( diagramMaler )
            print "done"
            piep()
            
            
        
# ----------------------------------------------------------
