class convHull:
    

    def __buildOgcHull(self,hull):
        string ="SRID=-1;POLYGON(("
        for i in hull:
            string += "%s %s,"%i
        string = string[:-1] +"))"
        return string
 
    def _myDet(self,p, q, r):
        sum1 = q[0]*r[1] + p[0]*q[1] + r[0]*p[1]
        sum2 = q[0]*p[1] + r[0]*q[1] + p[0]*r[1]
        return sum1 - sum2
    
    def _isRightTurn(self,(p, q, r)):
        if self._myDet(p, q, r) < 0:
            return 1
        else:
            return 0

    def __init__(self,storageObject):
        
        self.storageObject = storageObject
        self.hull = self.__convexHull()
    
        self.ogcHull = self.__buildOgcHull(self.hull)
       
        
    def getHull(self):
        return self.hull
    
    def getOgcHull(self,hull=None):
        if hull == None:
            hull = self.hull
        return self.__buildOgcHull(hull)
    
    

    def __convexHull(self):
        """Calculate the convex hull of a set of points and returns it as list of tuples"""
        points=[]
        #for all shapes in shapefile
        for shape in self.storageObject.AllShapes():
            
            #for all vertices in shape
            for vert in shape.Points():
                #for all points of vertice
                for p in vert:
                    points.append(p)
        
        
        
        # Get a local list copy of the points and sort them lexically.
        #points = map(None, P)
        punkte=map(None,points)
        points.sort()
        firstpoint = points[0]

        # Build upper half of the hull.
        upper = [points[0], points[1]]
        for p in points[2:]:
            upper.append(p)
            while len(upper) > 2 and not self._isRightTurn(upper[-3:]):
                del upper[-2]
        
        # Build lower half of the hull.
        points.reverse()
        lower = [points[0], points[1]]
        for p in points[2:]:
            lower.append(p)
            while len(lower) > 2 and not self._isRightTurn(lower[-3:]):
                del lower[-2]
        
        # Remove duplicates.
        del lower[0]
        del lower[-1]
        lower.append(firstpoint)
        # Concatenate both halfs and return.
        return upper + lower