import os

#from shapeStoreBuilder import PirolShapeFileShape
from Thuban.Model import table
from data_fake import MemoryShapeStore

class csvError(Exception):
    def __init__(self,message):
        self.message =message
    def __str__(self):
        return repr(self.message)

class csvHeader:
    def __init__(self,lineone,linetwo,linethree,seperator=";", justFetchRows = False):
        #baut ein Dict mit Typ und zugehoeriger einheit
        #falls lineone oder linetwo nicht mit $beginnen oder irgedwie keine 
        #gueltigen Zeilen sind wir eine csvException geworfen
        self.header={}
        self.col_map = {}
        lineone = lineone.strip().strip("\n")
        linetwo = linetwo.strip().strip("\n")
        linethree = linethree.strip().strip("\n")
        if (lineone[0:1] != "$"):
            raise csvError("Zeile 1 ist keine gueltige Pirol csv  Headerzeile, sie muss mit $ beginnen")
        if (linetwo[0:1] != "$"):
            raise csvError("Zeile 2 ist keine gueltige Pirol csv  Headerzeile, sie muss mit $ beginnen")
        if (linethree[0:1] != "$"):
            raise csvError("Zeile 3 ist keine gueltige Pirol csv  Headerzeile, sie muss mit $ beginnen")
        #ok nun checken wir die zeilen
        keys = lineone[1:].split(seperator)
        if ( not justFetchRows ):
            if len(keys) < 2:
                raise csvError("Trennzeichen " +seperator + " in Spaltenueberschriften nicht gefunden")
            units = linetwo[1:].split(seperator)
            if len(units) < 2:
                raise csvError("Trennzeichen " +seperator + " Einheiten nicht gefunden")
            types = linethree[1:].split(seperator)
            if len (types) < 2:
                raise csvError("Trennzeichen " +seperator + " Datentypen nicht gefunden")
            if len(units) != len (keys):
                raise csvError("Nicht die gleiche Anzahl von Schluesseln und Einheiten")
            if len(units) != len (types):
                raise csvError("Nicht die gleiche Anzahl von Einheiten und Datentypen")
            if len(keys) != len (types):
                raise csvError("Nicht die gleiche Anzahl von Schluesseln und Datentypen")
        
            self.headerlen=len(types)
        
            #und basteln das dict
            for i  in range(self.headerlen):
                self.header[keys[i]]=(units[i],types[i])
                #self.header[i]=keys[i] # tut nicht!! dicts sind verdammtnochmal keine lists -> reihenfolge (was soll da ueberhaupt rauskommen??)!
                self.col_map[i]=keys[i]
            
    def __str__(self):
        outstr = ""
        for k,u in self.header.iteritems():
            outstr += "%s[%s] | " %(k,u)
        return outstr[:-2]
    
    def getHeader(self):
        return self.header
        
    def getColMap(self):
        return self.col_map
                
        
        
class csvReader:
    
    def __init__(self,filename,seperator, xcol, ycol, justFetchRows = False):
        self.filename=filename
        self.seperator=seperator
        self.file = None
        self.csvHeader = None
        self.linecount=0
        
        self.xCol = xcol
        self.yCol = ycol
        
        try:
            self.file = open(filename,"r")
        except IOError:
            raise csvError("Kann die CsvDatei %s nicht oeffnen" %filename)
            return 
        
        self.lineone = self.file.readline()
        self.linetwo = self.file.readline()
        self.linethree = self.file.readline()
        self.csvHeader = csvHeader(self.lineone,self.linetwo,self.linethree,seperator, justFetchRows )
        
            
            
        self.linecount = 2
    
    def getForthLineAsString( self ):
        return self.file.readline()
        
    def __str__(self):
        outstr =""
        outstr += "opened %s\nHeader: %s" %(self.filename ,self.csvHeader)
        return outstr 

    def _reopen(self):
        try:
            self.file.close()
            self.file = open(self.filename,"r")
        except IOError:
            raise csvError("Kann die CsvDatei %s nicht oeffnen" %self.filename)
            return 
        
    def fetchLineAsDict(self):
        buffer = self.file.readline().strip().strip("\n")
        retdict = {}
        #print buffer
        if len (buffer) <= 0:
            return None
        line = buffer.split(self.seperator)
        self.linecount += 1
        if len(line)<2 :
            raise csvError("Trennzeichen " +seperator + " in Daten nicht gefunden Zeile:%d"%self.linecount)
        for i in range(len(line)):
            key =  self.csvHeader.getColMap()[i]
            unit,type =  self.csvHeader.getHeader()[key]
            retdict[ key ] = (line[i],unit,type)
        return retdict
    
    def fetchLineAsTuple(self):
        buffer = self.file.readline().strip().strip("\n")
        if len (buffer) <= 0:
            return None
        line = buffer.split(self.seperator)
        self.linecount += 1
        if len(line)<2 :
            raise csvError("Trennzeichen " +seperator + " in Daten nicht gefunden Zeile:%d"%self.linecount)
        newline=[]
        header =  self.csvHeader.getHeader()
        colmap =  self.csvHeader.getColMap()

        for i in range(len(line)):
            unit,datatype = header[ colmap[i] ]
            if datatype.lower() == str(table.FIELDTYPE_DOUBLE).lower():
                if (line[i].find(",") > -1):
                    line[i]=line[i].replace( ",", "." )
                newline.append(float(line[i]))
            elif datatype.lower() == str(table.FIELDTYPE_INT).lower():
                newline.append(int(line[i]))
            elif datatype.lower() == str(table.FIELDTYPE_STRING).lower():
                newline.append(str(line[i]))
            else:
                print "Unbekannter Datentyp"
        return tuple(newline)
            
    def getAllLines(self):
        retlist = []
        self._reopen()
        for i in range(3):
            temp = self.file.readline()
            
        buffer = self.fetchLineAsTuple()
        while buffer:
            
            retlist.append(buffer)
            buffer = self.fetchLineAsTuple()
        return retlist
    
    def getMemTable(self):
        #erstmal header basteln
        header =[]
        csvheader = self.csvHeader.getHeader()
        cols = self.csvHeader.getColMap()
#        if self.csvHeader.headerlen < 3 :
#            raise csvError("Datensatz besteht nur aus Koordinaten")
#            return None
        
        for i in range(self.csvHeader.headerlen):
            unit,type= csvheader[cols[i]]
            header.append ( (cols[i],type))
        #ok header fertig
        # nun die daten
        data = self.getAllLines()
        return  table.MemoryTable(header,data)

    def getShapeStore(self):
        memShapeStore=None
        memTable=self.getMemTable()
        header =[]
        csvheader = self.csvHeader.getHeader()
#        if self.csvHeader.headerlen < 3 :
#            raise csvError("Datensatz besteht nur aus Koordinaten")
#            return None
        
        memShapeStore=MemoryShapeStore()
        print "------------------------------------------------"
        data = self.getAllLines() 
        for record in data:
            x=record[self.xCol]
            y=record[self.yCol]
            
#            if (x.find(",") > -1):
#                x = x.replace( ",", "." )
#            if (y.find(",") > -1):
#                y = y.replace( ",", "." )
            
#            memShapeStore.addPoint(float(x),float(y))
            memShapeStore.addPoint(x,y)
            
            
        memShapeStore.setTable(memTable)
    
        ys=[]
        xs=[]
        for shape in memShapeStore.AllShapes():
            for part in shape.Points():
                for x,y in part:
                    
                    xs.append(x)
                    ys.append(y)
        
        memShapeStore.Table().SetTitle( self.filename )
        
        memShapeStore.bbox = (min(xs),min(ys),max(xs),max(ys)) 
        print  memShapeStore.bbox 
        return memShapeStore
            
#try:    
#    test = csvReader("/home/bernd/hink/testcsv.txt","\t")
    
#except csvError,e:
#    print e.message
#    os.exit (0)
#print test
#for i in test.getAllLines():
#    print i
#test.getMemTable()
        