#-----------------------------------------------------------------------------
# Name:        csv_dialog.py
# Purpose:     
#
# Author:      orahn
#
# Created:     2004/22/09
# RCS-ID:      $Id: csv_dialog.py,v 1.4 2004/09/23 11:46:34 orahn Exp $
#-----------------------------------------------------------------------------
#Boa:Dialog:CSV_Dialog

from wxPython.wx import *
from wxPython.grid import *

def create(parent):
    return CSV_Dialog(parent)

[wxID_CSV_DIALOG, wxID_CSV_DIALOGBUTTON_CANCEL, wxID_CSV_DIALOGBUTTON_OK, 
 wxID_CSV_DIALOGCOMBOBOX_NORD, wxID_CSV_DIALOGCOMBOBOX_OST, 
 wxID_CSV_DIALOGCOMBOBOX_SEPARATOR, wxID_CSV_DIALOGGRID1, 
 wxID_CSV_DIALOGSTATICBOX_VORSCHAU, wxID_CSV_DIALOGSTATICTEXT_NORD, 
 wxID_CSV_DIALOGSTATICTEXT_OST, wxID_CSV_DIALOGSTATICTEXT_SEPARATOR, 
 wxID_CSV_DIALOGSTATICTEXT_VORSCHTEXT, wxID_CSV_DIALOGTEXTCTRL_VORSCHAU, 
] = map(lambda _init_ctrls: wxNewId(), range(13))

class CSV_Dialog(wxDialog):
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wxDialog.__init__(self, id=wxID_CSV_DIALOG, name='CSV_Dialog',
              parent=prnt, pos=wxPoint(284, 176), size=wxSize(548, 445),
              style=wxDEFAULT_DIALOG_STYLE,
              title='Einstellungen zum Einlesen einer CSV-Datei')
        self.SetClientSize(wxSize(548, 445))

        self.staticText_nord = wxStaticText(id=wxID_CSV_DIALOGSTATICTEXT_NORD,
              label='Spalte fuer die Nord- bzw. Sued-Koordinate:',
              name='staticText_nord', parent=self, pos=wxPoint(40, 40),
              size=wxSize(247, 16), style=0)

        self.comboBox_nord = wxListBox(choices=[],
              id=wxID_CSV_DIALOGCOMBOBOX_NORD, name='comboBox_nord',
              parent=self, pos=wxPoint(312, 32), size=wxSize(200, 32), style=wxLB_SINGLE)

        EVT_LISTBOX(self.comboBox_nord, wxID_CSV_DIALOGCOMBOBOX_NORD,
              self.OnComboBox_nordCombobox)

        self.staticText_ost = wxStaticText(id=wxID_CSV_DIALOGSTATICTEXT_OST,
              label='Spalte fuer die Ost- bzw. West-Koordinate:',
              name='staticText_ost', parent=self, pos=wxPoint(40, 80),
              size=wxSize(237, 16), style=0)

        self.comboBox_ost = wxListBox(choices=[],
              id=wxID_CSV_DIALOGCOMBOBOX_OST, name='comboBox_ost', parent=self,
              pos=wxPoint(312, 72), size=wxSize(200, 32), style=wxLB_SINGLE)

        EVT_LISTBOX(self.comboBox_ost, wxID_CSV_DIALOGCOMBOBOX_OST,
              self.OnComboBox_ostCombobox)

        self.staticText_separator = wxStaticText(id=wxID_CSV_DIALOGSTATICTEXT_SEPARATOR,
              label='Trennzeichen in der Datei:', name='staticText_separator',
              parent=self, pos=wxPoint(40, 120), size=wxSize(200, 16), style=0)

        self.comboBox_separator = wxComboBox(choices=[],
              id=wxID_CSV_DIALOGCOMBOBOX_SEPARATOR, name='comboBox_separator',
              parent=self, pos=wxPoint(312, 112), size=wxSize(200, 22), style=wxCB_READONLY)

        EVT_COMBOBOX(self.comboBox_separator, wxID_CSV_DIALOGCOMBOBOX_SEPARATOR,
              self.OnComboBox1Combobox)

        self.grid1 = wxGrid(id=wxID_CSV_DIALOGGRID1, name='grid1', parent=self,
              pos=wxPoint(40, 224), size=wxSize(472, 96), style=0)
        self.grid1.EnableEditing(False)

        self.staticText_VorschText = wxStaticText(id=wxID_CSV_DIALOGSTATICTEXT_VORSCHTEXT,
              label='Beispiel Punkt:', name='staticText_VorschText',
              parent=self, pos=wxPoint(40, 192), size=wxSize(82, 96), style=0)

        self.staticBox_Vorschau = wxStaticBox(id=wxID_CSV_DIALOGSTATICBOX_VORSCHAU,
              label='Vorschau', name='staticBox_Vorschau', parent=self,
              pos=wxPoint(32, 168), size=wxSize(496, 184), style=0)

        self.textCtrl_vorschau = wxTextCtrl(id=wxID_CSV_DIALOGTEXTCTRL_VORSCHAU,
              name='textCtrl_vorschau', parent=self, pos=wxPoint(144, 192),
              size=wxSize(368, 20), style=0)

        self.button_ok = wxButton(id=wxID_CSV_DIALOGBUTTON_OK, label='OK',
              name='button_ok', parent=self, pos=wxPoint(328, 400),
              size=wxSize(88, 22), style=0)
        EVT_BUTTON(self.button_ok, wxID_CSV_DIALOGBUTTON_OK,
              self.OnButton_okButton)

        self.button_cancel = wxButton(id=wxID_CSV_DIALOGBUTTON_CANCEL,
              label='Abbrechen', name='button_cancel', parent=self,
              pos=wxPoint(432, 400), size=wxSize(80, 22), style=0)
        EVT_BUTTON(self.button_cancel, wxID_CSV_DIALOGBUTTON_CANCEL,
              self.OnButton_cancelButton)

    def __init__(self, parent, firstLine, fourthLine):
        self._init_ctrls(parent)
        
        self.firstLine = firstLine.strip("$")
        self.firstLine = self.firstLine.strip("\n")
        self.fourthLine = fourthLine.strip("\n")
        
        self.separators = { "Tabulator":"\t",
                            "Komma":",",
                            "Semikolon":";",
                            "Leerzeichen":" "}
        
        self.separator = "Tabulator"
        self.comboBox_separator.Clear()
        for sep in self.separators.keys():
            self.comboBox_separator.Append( sep )
        
        self.spalte_nord = 0
        self.spalte_ost = 0
        
        self.spalten = self.firstLine.split(self.separators[self.separator])
        self.grid1.CreateGrid( 1, len(self.spalten) )
        
        self.atWork = False
        
        self.refreshPreview()
        
        self.result = {}

    def OnComboBox_nordCombobox(self, event):
        if (self.atWork):
            return
        print "OnComboBox_nordCombobox", self.comboBox_nord.GetSelection()
        neuspalte_nord = -1
        if ( self.comboBox_nord.GetCount()!=0 ):
            neuspalte_nord = self.comboBox_nord.GetSelection()
        else:
            print "self.comboBox_nord.IsEmpty()"
            return

        if ( neuspalte_nord > -1 and neuspalte_nord != self.spalte_nord ):
            self.spalte_nord = neuspalte_nord
            self.refreshPreview()

    def OnComboBox_ostCombobox(self, event):
        if (self.atWork):
            return
        neuspalte_ost = -1
        if ( self.comboBox_ost.GetCount()!=0 ):
            neuspalte_ost = self.comboBox_ost.GetSelection()
        else:
            print "self.comboBox_ost.IsEmpty()"
            return


        if ( neuspalte_ost > -1 and neuspalte_ost != self.spalte_ost ):
            self.spalte_ost = neuspalte_ost
            self.refreshPreview()
            

    def OnComboBox1Combobox(self, event):
        if (self.atWork):
            return
        # Separator Auswahl
        self.separator = self.comboBox_separator.GetValue()
        print "Separator: ->", self.separator, "<-"
        # resetting 
        self.spalte_nord = 0
        self.spalte_ost = 0
        
        
        self.refreshPreview()
        
        
        
    def _machComboBoxLeer( self, cbox ):
        # kackt ab mit wxComboBox:
        cbox.Clear()

            
    def refreshPreview( self ):
        print "refreshPreview"
        self.atWork = True
        
        self.spalten = self.firstLine.split(self.separators[self.separator])
        numSpalten = len( self.spalten )
        
        print "- comboboxes"
        
        self._machComboBoxLeer( self.comboBox_nord )
        self._machComboBoxLeer( self.comboBox_ost )

        self.comboBox_nord.InsertItems( self.spalten,0 )
        self.comboBox_ost.InsertItems( self.spalten,0 )

            
        if ( numSpalten > self.spalte_nord and self.comboBox_nord.GetCount() > self.spalte_nord):
            self.comboBox_nord.SetSelection( self.spalte_nord )
        if ( numSpalten > self.spalte_ost and self.comboBox_ost.GetCount() > self.spalte_ost):
            self.comboBox_ost.SetSelection( self.spalte_ost )
        
        print "- separators"
        if ( self.separator != self.comboBox_separator.GetValue() ):
            self.comboBox_separator.SetSelection( self.comboBox_separator.FindString(self.separator)  )

            

        print "- preview"
        felder = self.fourthLine.split(self.separators[self.separator])
        print "- - felder:", felder

        if ( len(felder) > self.spalte_nord and len(felder) > self.spalte_ost ):
            strng = "Punkt( Nord="+felder[self.spalte_nord]+", Ost="+felder[self.spalte_ost]+" )"
            self.textCtrl_vorschau.SetValue( strng )
        else:
            self.textCtrl_vorschau.SetValue( "Vorschau nicht moeglich" )

        self.grid1.DeleteCols(0, self.grid1.GetNumberCols(), True)
        self.grid1.DeleteRows(0, 1, True)

        aktuelleZeile = felder

        self.grid1.InsertCols( 0, len(self.spalten) )
        self.grid1.InsertRows( 0, 1 )
        self.grid1.SetRowLabelValue( 0, "1" )
        
        for i in range( len( self.spalten ) ):
            self.grid1.SetColLabelValue( i, self.spalten[i] )

        for j in range( len(aktuelleZeile) ):
            self.grid1.SetCellValue(0, j, str(aktuelleZeile[j]) )
           

        self.atWork = False
        print "- ende" 
                
    def RunDialog(self):
        retVal = self.ShowModal()
        print "dialog:", retVal
        self.Destroy()
        return self.result
    
    def endDialog( self ):
        if self.result is not None:
            self.EndModal(wxID_OK)
        else:
            self.EndModal(wxID_CANCEL)
        self.Show(False)

    def OnButton_okButton(self, event):
        self.result = { "nord":self.spalte_nord, "ost":self.spalte_ost, "sep":self.separators[self.separator] }
        self.endDialog()

    def OnButton_cancelButton(self, event):
        self.result = None
        self.endDialog()
        
