from __future__ import generators

from logger import Logger
import dbWriter
from derivedTables import *
from Thuban.Model.postgisdb import type_map
from Thuban.Model.postgisdb import shapetype_map

from Thuban.Model import table
import psycopg
type_map.append( (psycopg.DATETIME,table.FIELDTYPE_STRING ))
type_map.append( (27722,table.FIELDTYPE_STRING))
from time import sleep
from logger import *

theFactory=None

class TiefenAttribut:
	def __init__(self,tiefe,tiefenid=None):
		self.tiefe=tiefe
		self.tiefenid=tiefenid
		self.attributnames=[]
		self.datatypes=[]
		self.attributtypids=[]
		
	def addAttributtyp(self,attributname,datatyp,attributtypid=None):
		self.attributnames.append(attributname)
		self.datatypes.append(datatyp)
		self.attributtypids.append(attributtypid)
		
	def __str__(self):
		return "names:%s datatyes:%s ids:%s"%(self.attributnames,self.datatypes,self.attributtypids)
	
		
class TiefenAttributContainer:
	
	def __init__(self):
		self.tiefenAttributDict = {}
		self.tiefenlist=[]
		self.attriblist=[]
		self.typeslist=[]
		
	def addTiefenAttribut(self,tiefenattribut):
		self.tiefenAttributDict[tiefenattribut.tiefe]=tiefenattribut
	
	def getTiefenAttribut(self,tiefe):
		if not self.tiefenAttributDict.has_key(tiefe):
			return None
		return self.tiefenAttributDict[tiefe]
	
	def getAll(self):
		for i in self.tiefenAttributDict.keys():
			yield (self.tiefenAttributDict[i])

	def setTiefenlist(self,liste):
		self.tiefenlist=liste
	
	def setAttriblist(self,liste):
		self.attriblist=liste
		
	def setTypeslist(self,liste):
		self.typeslist=liste
			
	def getTiefenlist(self):
		return self.tiefenlist
	
	def getAttriblist(self):
		return self.attriblist
	
	def getTypeslist(self):
		return self.typeslist
	
	def getTypeOfAttrib(self,attribname):
		for i in range(len(self.attriblist)):
			if attribname == self.attriblist[i]:
				return self.typeslist[i]

	def getIdofAttrib(self,attribname):
		for i in range(len(self.attriblist)):
			if attribname == self.attriblist[i]:
				return self.typeslist[i]

class DbFactory:
	tablemap={"schlag":"DbSchlag",
			"tiefe":"DbTiefe",
			"attributliste":"DbAttributListe",
			"attribut_typ":"DbAttributTyp",
			"raster":"DbRaster",
			"geom":"DbGeom",
			"geompoint":"DbGeomPoint",
			"geompoly":"DbGeomPoly",
			"geommultilinestring":"DbGeomMultiLineString",
			"geommultipoly":"DbGeomMultiPoly",
			"attribut":"DbAttribut",
			"gruppe":"DbGruppe",
			"diagramm":"DbDiagramm"}
	
	def __init__(self,db,logger):
		self.logger = logger
		self.db = db
		self.percent = 0
		self.fertig=False
		self.result = None
	
	
	def getDbFactory(db=None):
		global theFactory
		logger = Logger.getLogger()
		if ( theFactory == None ):
			theFactory = DbFactory(db,logger)
		return theFactory
	
	getDbFactory = staticmethod( getDbFactory )
        	
	def getPercent(self):
		return self.percent
	
	def Fertig(self):
		return self.fertig
		
	def dbTableFromId(self,tablename,pkid):
		evalstr = DbFactory.tablemap[tablename]
		
		logger=self.logger
		db=self.db
		evalstr += "(db,logger,pkid)"
		object = eval(evalstr)
		if object == None:
			return object
			
		object.fillFromDB()
		return object
	
	def dbTiefenFromSchlagId(self,schlagid):
		curs = self.db.cursor()
		stmt = "select tiefen_id from tiefe where schlag_id=%d order by tiefe"%schlagid
		curs.execute(stmt)
		result = curs.fetchall()
		tiefen = []
		for i in result :
			temp = DbTiefe(db=self.db,logger=self.logger,schlagid=schlagid,tiefenid=i[0])
			temp.fillFromDB()
			tiefen.append(temp)
		return tiefen
	
	def dbTiefe(self,schlagid,tiefe):
		curs = self.db.cursor()
		stmt = "select tiefen_id from tiefe where schlag_id=%d and tiefe=%s"%(schlagid,tiefe)
		curs.execute(stmt)
		result = curs.fetchone()
		tiefe=None
		if result != None:
			tiefe = DbTiefe(db=self.db,logger=self.logger,schlagid=schlagid,tiefenid=result[0])
			tiefe.fillFromDB()
		
		return tiefe
	
	
	def dbAllGeomFromSchlag(self,schlagid):
		curs = self.db.cursor()
		stmt = "select geom_id from geompoint where schlag_id=%d"%schlagid
		curs.execute(stmt)
		result = curs.fetchall()
		geoms = []
		for i in result :
			temp=DbGeomPoint(self.db,self.logger,i[0])
			temp.fillFromDB()
			geoms.append(temp)
		return geoms
	
	def dbRootGeomsFromSchlagId(self,schlagid):
		curs = self.db.cursor()
		stmt = "select distinct root,parent from geom where schlag_id=%d "%schlagid
		curs.execute(stmt)
		result = curs.fetchall()
		geoms = []
		
		for i in result: 
			root,parent = i
			temp = DbGeomPoint(self.db,self.logger,root)
			temp.fillFromDB()
			geoms.append(temp)
		return geoms
		
	def dbParentFromSchlagID(self,schlagid):
		curs = self.db.cursor()
		stmt = "select parent from schlag where schlag_id=%d and parent not NULL"%schlagid
		curs.execute(stmt)
		result = curs.fetchone()
		if result != None:
			temp = DbSchlag(self.db,self.logger,result[0])
			temp.fillFromDB()
			return temp 
	
	
	
	def dbRootNodeFromGeomId(self,geomid):
		curs = self.db.cursor()
		stmt = "select root from geom where geom_id=%d "%geomid
		curs.execute(stmt)
		result = curs.fetchone()
		if result != None:
			temp=DbGeomPoint(self.db,self.logger,result[0])
			temp.fillFromDB()
			return temp 

	def dbSchlagFromConvexHull(self,ogcConvHull):
		curs = self.db.cursor()
		stmt = "select schlag_id from schlag where equals(geomBorderPoly,'%s')"%ogcConvHull
		curs.execute(stmt)
		result = curs.fetchone()
		if result != None:
			temp = DbSchlag(self.db,self.logger,result[0])
			temp.fillFromDB()
			return temp 
	
	def dbSchlagFromConvexHullNew(self,ogcConvHull):
		ret = []
		curs = self.db.cursor()
		stmt = "select schlag_id from schlag where intersects(geomBorderPoly,'%s')"%ogcConvHull
		curs.execute(stmt)
		result = curs.fetchall()
		for i in result:
			
			temp = DbSchlag(self.db,self.logger,i[0])
			temp.fillFromDB()
			ret.append(temp)
			
		return ret

	def dbSchlagFromInnerPoint(self,ogcPoint):
		curs = self.db.cursor()
		stmt = "select schlag_id from schlag where contains(geomBorderPoly,'%s')"%ogcPoint
		curs.execute(stmt)
		result = curs.fetchone()
		if result != None:
			temp = DbSchlag(self.db,self.logger,result[0])
			temp.fillFromDB()
			return temp 
	
	def dbSchlagFromParent(self,schlagid):
		curs = self.db.cursor()
		stmt = "select schlag_id from schlag where parent=%d "%schlagid
		curs.execute(stmt)
		result = curs.fetchall()
		schlaege=[]
		
		for i in result:
			temp = DbSchlag(self.db,self.logger,i[0])
			temp.fillFromDB()
			schlaege.append(temp)
		return schlaege
	
	def dbSchlagAll(self):
		curs = self.db.cursor()
		stmt = "select schlag_id from schlag"
		curs.execute(stmt)
		result = curs.fetchall()
		schlaege=[]
		
		for i in result:
			temp = DbSchlag(self.db,self.logger,i[0])
			temp.fillFromDB()
			schlaege.append(temp)
		return schlaege
	
	def dbGeomFromParent(self,geomid):
		curs = self.db.cursor()
		stmt = "select geom_id from geom where parent=%d "%geomid
		curs.execute(stmt)
		result = curs.fetchall()
		geoms=[]
		
		for i in result:
			temp = DbGeomPoint(self.db,self.logger,i[0])
			temp.fillFromDB()
			geoms.append(temp)
		return geoms
		
	def dbGruppeFromSchlag(self,schlagid):
		curs = self.db.cursor()
		rootGeoms = self.dbRootGeomsFromSchlagId(schlagid)
		gruppen = []
		for i in rootGeoms:
			id = i.geomid
			stmt = "select gruppen_id from gruppe where geom_id=%d "%id
			curs.execute(stmt)
			result = curs.fetchall()
			for j in result:
				temp=DbGruppe(self.db,self.logger,gruppenid=j[0])
				temp.fillFromDB()
				gruppen.append(temp)
		return gruppen

	def dbAttrributTyp(self,schlagid,tiefenid):
		curs = self.db.cursor()
		atttypen=[]
		stmt = "select atttyp_id from attribut_typ where schlag_id=%d and tiefen_id=%d "%(schlagid,tiefenid)
		curs.execute(stmt)
		result = curs.fetchall()
		for i in result:
			temp=DbAttributTyp(self.db,self.logger,atttypid=i[0],schlagid=schlagid,tiefenid=tiefenid)
			temp.fillFromDB()
			atttypen.append(temp)
		return atttypen
	
		
	def dbDiagrammFromGruppe(self,gruppenid):
		curs = self.db.cursor()
		diagramme=[]
		stmt = "select diagramm_id from diagramm where gruppen_id=%d"%gruppenid
		curs.execute(stmt)
		result = curs.fetchall()
		for i in result:
			temp=DbDiagramm(self.db,self.logger,diagrammid=i[0])
			temp.fillFromDB()
			diagramme.append(temp)
		return diagramme
	
	def dbDiagrammFromName(self,name,typ):
		self.fertig=False
		diagramme=[]
		curs = self.db.cursor()
		stmt = "select diagramm_id from diagramm where name='%s' and typ='%s'"%(name,typ)
		curs.execute(stmt)
		result = curs.fetchall()
		length = len(result)
		self.fertig = False
		for i in result:
			temp=DbDiagramm(self.db,self.logger,diagrammid=i[0])
			temp.fillFromDB()
			diagramme.append(temp)
			self.percent = (99.5/length) * len(diagramme)
		self.result = diagramme
		sleep(0.1)
		self.fertig = True

	def getVorfahrFromSchlagID(self,schlagid):
		retval=[]
		curs = self.db.cursor()
		stmt = "select vorfahr_id from schlagVorfahr where schlag_id=%d" %schlagid
		curs.execute(stmt)
		result = curs.fetchall()
		for i in result:
			temp = DbSchlag(self.db,self.logger,i[0])
			temp.fillFromDB()
			retval.append(temp)
		return retval
		
		
		
	
	def getDataFromGroup(self,gruppenid=None,tiefen=None,targetStoreObject=None):
		self.fertig=False
		self.percent=0
		if gruppenid ==  None:
			return False
		if targetStoreObject == None:
			return False
		retval={}
		returnValue={}
		headermap={}
		header =[]
		geomrootid = None
		curs = self.db.cursor()
		stmt = "select geom_id,schlag_id from geom natural inner join gruppe where gruppen_id=%d " %gruppenid
		curs.execute(stmt)
		result = curs.fetchall()
		for i in result:
			geomrootid,dummy  =  i
		if geomrootid==None:
			return None

		tablename = "geompoint"
		targetStoreObject.shapetype = shapetype_map["POINT"]
		typeheader = {}
		stmt = "select g.geom,at.type,a.value from %s g, attribut a, attribut_typ at where 0=1 " %tablename
		curs.execute(stmt)
		description = curs.description 
		for i in range(len(description)):
			for pgtyp,tabletyp in type_map:
				if pgtyp == description [i] [1]:
					typeheader[description[i][0]]=tabletyp
					break
		
				
		if tiefen != None and len(tiefen)!=0:
			tiefenstmt = " and ("
			for i in tiefen :
				
				tiefenid = i
				tiefenstmt += "a.tiefen_id = %d or "%int(tiefenid)
			tiefenstmt = tiefenstmt[:-3]+") "
		else:
			tiefenstmt= " "
		
		stmt = "select distinct g.geom,at.type,a.value,at.datatype,g.shape_id from %s g, attribut a, attribut_typ at where " %tablename
		stmt += "a.geom_id = g.geom_id and g.root=%s "%geomrootid
		stmt += "and  a.atttyp_id = at.atttyp_id and a.tiefen_id=at.tiefen_id %s and a.schlag_id=at.schlag_id "%tiefenstmt
		stmt += "and a.schlag_id = g.schlag_id and at.schlag_id = g.schlag_id order by g.shape_id "
		curs.execute(stmt)
		result = curs.fetchall()
		length = len(result)
		rowcount = 0
		for row in result:
			rowcount += 1
			self.percent = (33.0/length)*rowcount
			geom = row[0]
			typ = row[1]
			value= row[2]
			datatype = row[3]
			shapeid=row[4]
			if retval.has_key(shapeid):
				liste = retval[shapeid]
				liste.append( (typ,value,geom) )
				headermap[typ] = datatype 
				retval[shapeid]=liste
			else:
				liste=[(typ,value,geom)]
				headermap[typ] = datatype
				retval[shapeid]=liste
		
		data = []
		retval.keys().sort()
		length+=len(retval.keys())
		for key in retval.keys():
			rowcount+=1
			self.percent = (66.6/length)*rowcount
			typ,val,geom = retval[key][0]
			targetStoreObject.addShape(geom)
			liste=[]
			for entry in retval[key]:
				if len(header)  !=  len(retval[key]):
					header.append( (entry[0],headermap[entry[0]]) )
				if headermap[entry[0]] == table.FIELDTYPE_INT:
					liste.append(   int (entry[1]))
				if headermap[entry[0]] == table.FIELDTYPE_DOUBLE:
					liste.append( float (entry[1]))
				if headermap[entry[0]] == table.FIELDTYPE_STRING:
					liste.append( str(entry[1]))
			tupel = tuple(liste)
			data.append(tupel)
			
			
		
		#ok wir haben die daten nun im MemoryTable Format als liste von Tupeln
		# und nun nen MemoryTable erzeugen
		targetStoreObject.table = table.MemoryTable(header,data)
		xs=[]
		ys=[]
		length+=targetStoreObject.NumShapes()
		
		for shape in targetStoreObject.AllShapes():
			rowcount+=1
			self.percent = (99.0/length)*rowcount
			for part in shape.Points():
				for x,y in part:
					xs.append(x)
					ys.append(y)
		
		targetStoreObject.bbox = (min(xs),min(ys),max(xs),max(ys)) 
		
		self.fertig=True

	def attribtiefenlist(self,schlagid):
		#baut nen dict:
		#"attribut":[tiefenid1,...,tiefenidn],[atttypid1,....,atttypidn]
		curs = self.db.cursor()
		stmt ="select tiefen_id,atttyp_id,tiefe,type from tiefe natural inner join attribut_typ where schlag_id = %d order by tiefe "%(schlagid)
		curs.execute(stmt)
		result = curs.fetchall()
		retlist={}
		list=[]
		for record in result:
			tiefenid=record[0]
			atttypid=record[1]
			tiefe=record[2]
			typ=record[3]
			if retlist.has_key(typ):
				list=retlist[typ]
				list[0].append(tiefenid)
				list[1].append(atttypid)
			else:
				list = [ [tiefenid],[atttypid] ]
				retlist[typ] = list
		return retlist
		
		
	
			