import sys
try:
	import psycopg
except:
	pyscopg=None


if psycopg is not None:
    type_map = [(psycopg.STRING, "string"),
                (psycopg.INTEGER, "int"),
                (psycopg.FLOAT, "double"),
		(psycopg.DATETIME,"datetime"),
		(psycopg.DATE,"date")]

theDbWriter = None
	
class dbWriter:
	instanceCounter = 0
	def __init__(self,connection):
		#dbConnectString = "dbname="+pgdb+" user="+pguser+" host="+pghost+" password="+pgpass
		if dbWriter.instanceCounter >0 :
			print "ERROR: DBWriter Instance cloned!!!"
			sys.exit(1)
		
		try:
			self.postGisConn = connection
			self.conn = connection.connection #psycopg.connect(connectString)
			self.conn.autocommit(0)
			self.curs = self.conn.cursor()
			dbWriter.instanceCounter = dbWriter.instanceCounter + 1
			self._getGeomType()
			global type_map
			type_map.append((self.geometry_type,"geometry"))
			self.description={}
			
		except psycopg.OperationalError, detail:
			print detail
			sys.exit(1)
	
	def getDbWriter(conn=None):
		global theDbWriter
		if ( theDbWriter == None ):
			theDbWriter = dbWriter(conn)
		return theDbWriter
	
	getDbWriter = staticmethod( getDbWriter )
	
	def _getGeomType(self):
		self.curs.execute("SELECT OID, typname FROM pg_type WHERE typname = 'geometry'")
		row = self.curs.fetchone()
		if row is not None:
			self.geometry_type = row[0]
		else:
			raise ValueError("Can't determine postgres type of geometries")
	
	def disconnect(self):
		self.conn.commit()
		self.conn.close()
		self.description=""
		
	def select(self,query):
		if len(query) < 16:	#"select * from a;"
			return -1
		self.executeQuery(query)
		
					
			
			
		#self.description= [ (d[0],d[1])	for d in self.curs.description]
		return self.curs.fetchall()
	def cursor(self):
		return self.curs

	def insert(self,query):
		if len(query) < 18: 	# "insert into a (a);"
			return -1
		self.description=""
		return self.executeQuery(query)

	def delete(self,query):
		if len(query) < 14:	# "delete from a;"
			return -1
		self.description=""
		return self.executeQuery(query)
	def update(self,query):
		if len(query) < 17:	#"update a set a=a;"
			return -1
		self.description=""
		return self.executeQuery(query)

	def executeQuery(self,query):
		result = self.curs.execute(query)
		for i in range(len(self.curs.description)):
			for k,v in type_map:
				if k == self.curs.description[i][1]:
					self.description[self.curs.description[i][0]]=v
		return result

	def getDescription(self):
		
		return self.description
	
	def commit(self):
		print "Commiting"
		self.conn.commit()
		
	def rollback(self):
		print "Rolling back"
		self.conn.rollback()
		
		