from abstractDbTable import AbstractTable
import dbWriter
class DbSchlag(AbstractTable):
	dbmap={"schlag_id":"schlagid" ,
		"name":"name",
		"datum":"datum",
		"geomborderpoly":"borderpoly"}

	def __init__(self,db,logger,schlagid=None,name=None,datum=None,borderPoly=None):
		
		AbstractTable.__init__(self,"schlag",db,logger)
		
		if schlagid != None:
			self.schlagid=int(schlagid)
		else:
			self.schlagid=int(self.getNewID("schlag"))
			
		self.pkid=[self.schlagid]
		self.name=name
		self.datum=self._parseDatum(datum)
		self.borderpoly=borderPoly
		self.new = 0
		

class DbSchlagVorfahr(AbstractTable):
	dbmap={"schlag_id":"schlagid",
			"vorfahr_id":"vorfahrid" }

	def __init__(self,db,logger,schlagid,vorfahrid):
			AbstractTable.__init__(self,"schlagvorfahr",db,logger)
			self.schlagid=schlagid
			self.vorfahrid=vorfahrid
			self.pkid=[self.schlagid]

			
		
class DbTiefe(AbstractTable):
	dbmap={"schlag_id":"schlagid",
		"tiefen_id":"tiefenid",
		"tiefe":"tiefe"}
	
	def __init__(self,db,logger,tiefenid=None,schlagid=None,tiefe=None):
		
		AbstractTable.__init__(self,"tiefe",db,logger)
		self.schlagid=schlagid
		if tiefenid != None:
			self.tiefenid=tiefenid
		else:
			self.tiefenid=self.getNewID("tiefe")
		self.pkid=[self.tiefenid,schlagid]
		self.tiefe=tiefe
	


class DbAttributListe(AbstractTable):
	dbmap={"schlag_id":"schlagid",
		"tiefen_id":"tiefenid",
		"name":"name",
		"description":"description"}
	
	def __init__(self,db,logger,schlagid=None,tiefenid=None,name=None,description=None):
		AbstractTable.__init__(self,"attributliste",db,logger)
		self.schlagid=schlagid
		self.tiefenid=tiefenid
		self.pkid=[tiefenid,schlagid]
		self.name = name
		self.description = description
	

class DbAttributTyp(AbstractTable):
	dbmap={"schlag_id":"schlagid",
		"tiefen_id":"tiefenid",
		"atttyp_id":"atttypid",
		"raster_id":"rasterid",
		"datatype":"datatype",
		"time":"time",
		"type":"typ"}
	
	def __init__(self,db,logger,schlagid=None,tiefenid=None,atttypid=None,rasterid=None,time=None,typ=None,datatype=None):
		AbstractTable.__init__(self,"attribut_typ",db,logger)
		self.schlagid=schlagid
		self.tiefenid=tiefenid
		
		if atttypid != None:
			self.atttypid=atttypid
		else:
			self.atttypid=self.getNewID("attribut_typ")
			
		self.pkid=[self.atttypid,tiefenid,schlagid]
		self.rasterid=rasterid
		self.time=self._parseDatum(time)
		self.typ=typ
		self.datatype=datatype
	




class DbRaster(AbstractTable):
	dbmap={"raster_id":"rasterid",
		"einheit":"einheit",
		"x_space":"x_space",
		"y_space":"y_space"}
	
	def __init__(self,db,logger,rasterid=None,einheit=None,x_space=None,y_space=None):
		AbstractTable.__init__(self,"raster",db,logger)
		if self.rasterid != None:
			self.rasterid=rasterid
		else:
			self.rasterid=self.getNewID()
		self.pkid=[self.rasterid]
		self.einheit=einheit
		self.x_space=x_space
		self.y_space=y_space
		


class DbGeom(AbstractTable):
	dbmap={"geom_id":"geomid",
		"schlag_id":"schlagid",
		"shape_id":"shapeid",
		"parent":"parent",
		"root":"root"}
	
	def __init__(self,db,logger,geomid=None,schlagid=None,shapeid=None,parent=None,root=None):
		AbstractTable.__init__(self,"geom",db,logger)
		if geomid != None:
			self.geomid=geomid
		else:
			self.geomid=self.getNewID("geom")
		self.schlagid=schlagid
		self.parent=parent
		self.root=root
		self.shapeid=shapeid
		self.pkid=[self.geomid]
	



class DbAbstractGeom(DbGeom):
	dbmap = DbGeom.dbmap 
	dbmap["geom"]="geom"
	
	def __init__(self,db,logger,geomid=None,schlagid=None,parent=None,root=None,geom=None):
		pass

class DbGeomPoint(DbAbstractGeom):
	
	def __init__(self,db,logger,geomid=None,schlagid=None,shapeid=None,parent=None,root=None,geom=None):
		AbstractTable.__init__(self,"geompoint",db,logger)
		
		if geomid != None:
			self.geomid=geomid
		else:
			self.geomid=self.getNewID("geom")
		self.schlagid=schlagid
		self.parent=parent
		self.root=root
		self.shapeid=shapeid
		self.geom=geom
		self.pkid=[self.geomid]
	


class DbGeomPoly(DbAbstractGeom):
	
	def __init__(self,db,logger,geomid=None,schlagid=None,parent=None,root=None,geom=None):
		AbstractTable.__init__(self,"geompoly",db,logger)

		if geomid != None:
			self.geomid=geomid
		else:
			self.geomid=self.getNewID("geom")


		self.schlagid=schlagid
		self.parent=parent
		self.root=root
		self.geom=geom
		self.pkid=[self.geomid]



class DbGeomMultiLineString(DbAbstractGeom):
	
	def __init__(self,db,logger,geomid=None,schlagid=None,parent=None,root=None,geom=None):
		AbstractTable.__init__(self,"geommultilinestring",db,logger)
		if geomid != None:
			self.geomid=geomid
		else:
			self.geomid=self.getNewID("geom")
		
		self.schlagid=schlagid
		self.parent=parent
		self.root=root
		self.geom=geom
		self.pkid=[self.geomid]

		
class DbGeomMultiPoly(DbAbstractGeom):
	
	def __init__(self,db,logger,geomid=None,schlagid=None,parent=None,root=None,geom=None):
		AbstractTable.__init__(self,"geommultipoly",db,logger)
		
		if geomid != None:
			self.geomid=geomid
		else:
			self.geomid=self.getNewID("geom")
		
		self.schlagid=schlagid
		self.parent=parent
		self.root=root
		self.geom=geom
		self.pkid=[self.geomid]

class DbAttribut(AbstractTable):
	dbmap = {"atttyp_id":"atttypid",
		"geom_id":"geomid",
		"tiefen_id":"tiefenid",
		"schlag_id":"schlagid",
		"value":"value"}
	
	def __init__(self,db,logger,atttypid=None,geomid=None,tiefenid=None,schlagid=None,value=None):
		AbstractTable.__init__(self,"attribut",db,logger)
		self.atttypid=atttypid
		self.geomid=geomid
		self.tiefenid=tiefenid
		self.schlagid=schlagid
		self.value=value
		self.pkid=[atttypid,tiefenid,schlagid,geomid]
		
	
	

class DbGruppe(AbstractTable):
	
	dbmap = {"gruppen_id":"gruppenid",
		"geom_id":"geomid",
		"datum":"datum",
		"name":"name",
		"beschreibung":"beschreibung"}
	
	def __init__(self,db,logger,gruppenid=None,geomid=None,datum=None,name=None,beschreibung=None):
		AbstractTable.__init__(self,"gruppe",db,logger)
		if gruppenid != None:
			self.gruppenid=gruppenid
		else:
			self.gruppenid=self.getNewID("gruppe")
		self.geomid=geomid
		self.datum=self._parseDatum(datum)
		self.name=name
		self.beschreibung=beschreibung
		self.pkid=[self.gruppenid]

class DbDiagramm(AbstractTable):
	
	dbmap = {"diagramm_id":"diagrammid",
		"gruppen_id":"gruppenid",
		"name":"name",
		"typ":"typ",
		"geom_kante":"geomkante",
		"pktlinks":"pktlinks",
		"pktrechts":"pktrechts" }
	
	def __init__(self,db,logger,diagrammid=None,gruppenid=None,name=None,typ=None,geomkante=None,pktlinks=None,pktrechts=None):
		AbstractTable.__init__(self,"diagramm",db,logger)
		if diagrammid != None:
			self.diagrammid=diagrammid
		else:
			self.diagrammid=self.getNewID("diagramm")

		self.gruppenid=gruppenid
		self.geomkante=geomkante
		self.name=name
		self.typ=typ
		self.pktlinks=pktlinks
		self.pktrechts=pktrechts
		self.pkid=[self.diagrammid]
		
