from wxPython.wx import *
from Thuban import _


class cluster_dialog(wxDialog):
    def __init__(self, parent, parameters, titel, message = ""):
        wxDialog.__init__(self, parent, -1, titel)
        self.attribute = parameters
        
        
        top = wxBoxSizer(wxVERTICAL)
        

        if message:
            top.Add(wxStaticText(self, -1, message), 0,
                    wxALL|wxALIGN_CENTER_VERTICAL, 4)
        
        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, _("ges. X-Attribut:")), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)
        self.text_xattr = wxComboBox(self, -1, "", (0,0), (-1,-1), parameters, wxCB_DROPDOWN )
        box.Add(self.text_xattr, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)

        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, _("ges. Y-Attribut:")), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)
        self.text_yattr = wxComboBox(self, -1, "", (0,0), (-1,-1), parameters, wxCB_DROPDOWN )
        box.Add(self.text_yattr, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)

        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, _("opt. Attribute:")), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)
        self.text_optattr = wxListBox(self, -1, choices = parameters, style = wxLB_MULTIPLE | wxLB_NEEDED_SB )
        box.Add(self.text_optattr, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)

        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, _("Schwellenwert Faktor:")), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)
        self.text_swf = wxTextCtrl(self, -1, "4.0" )
        box.Add(self.text_swf, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)

        buttons = wxBoxSizer(wxHORIZONTAL)
        button = wxButton(self, wxID_OK, _("OK"))
        buttons.Add(button, 0, wxALL, 4)
        button = wxButton(self, wxID_CANCEL, _("Cancel"))
        buttons.Add(button, 0, wxALL, 4)
        top.Add(buttons, 0, wxALIGN_RIGHT, 4)

        self.SetAutoLayout(1)
        self.SetSizer(top)
        top.Fit(self)
        top.SetSizeHints(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)
        EVT_BUTTON(self, wxID_CANCEL, self.OnCancel)

    def RunDialog(self):
        self.ShowModal()
        self.Destroy()
        return self.result

    def end_dialog(self, result):
        self.result = result
        if result is not None:
            self.EndModal(wxID_OK)
        else:
            self.EndModal(wxID_CANCEL)
        self.Show(False)

    def OnOK(self, event):
        result = {}
        optattr = []

        for i in self.text_optattr.GetSelections():
            optattr.append(self.attribute[i])
        result["optattr"] = optattr

        for name in ("xattr", "yattr", "swf"):
            result[name] = getattr(self, "text_" + name).GetValue()
            
        self.end_dialog(result)

    def OnCancel(self, event):
        self.end_dialog(None)

class doppelAttributAuswahl(wxDialog):
    def __init__(self, parent, parameters, titel, message = "", txtZahl="", txtText1="", txtText2=""):
        wxDialog.__init__(self, parent, -1, titel)
        self.attribute = parameters
        
        textZahl = _("Signifikanz (%):")
        if ( txtZahl != "" ):
            textZahl = txtZahl
        
        textText1 = _("Attribut 1:")
        if ( txtText1 != "" ):
            textText1 = txtText1
            
        textText2 = _("Attribut 2:")
        if ( txtText2 != "" ):
            textText2 = txtText2
        
        top = wxBoxSizer(wxVERTICAL)
        

        if message:
            top.Add(wxStaticText(self, -1, message), 0,
                    wxALL|wxALIGN_CENTER_VERTICAL, 4)

        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, textZahl), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)
        self.text_alpha = wxTextCtrl(self, -1)
        
        box.Add(self.text_alpha, 2, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)
        
        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, textText1), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)
        self.text_xattr = wxComboBox(self, -1, "", (0,0), (-1,-1), parameters, wxCB_DROPDOWN )
        box.Add(self.text_xattr, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)

        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, textText2), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)
        self.text_yattr = wxComboBox(self, -1, "", (0,0), (-1,-1), parameters, wxCB_DROPDOWN )
        box.Add(self.text_yattr, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)

        buttons = wxBoxSizer(wxHORIZONTAL)
        button = wxButton(self, wxID_OK, _("OK"))
        buttons.Add(button, 0, wxALL, 4)
        button = wxButton(self, wxID_CANCEL, _("Cancel"))
        buttons.Add(button, 0, wxALL, 4)
        top.Add(buttons, 0, wxALIGN_RIGHT, 4)

        self.SetAutoLayout(1)
        self.SetSizer(top)
        top.Fit(self)
        top.SetSizeHints(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)
        EVT_BUTTON(self, wxID_CANCEL, self.OnCancel)

    def RunDialog(self):
        self.ShowModal()
        self.Destroy()
        return self.result

    def end_dialog(self, result):
        self.result = result
        if result is not None:
            self.EndModal(wxID_OK)
        else:
            self.EndModal(wxID_CANCEL)
        self.Show(False)

    def OnOK(self, event):
        result = {}

        for name in ("xattr", "yattr", "alpha"):
            result[name] = getattr(self, "text_" + name).GetValue()
            
        self.end_dialog(result)

    def OnCancel(self, event):
        self.end_dialog(None)

class attributAuswahl(wxDialog):
    def __init__(self, parent, parameters, titel, message = "", text = ""):
        wxDialog.__init__(self, parent, -1, titel)
        self.attribute = parameters
        
        
        top = wxBoxSizer(wxVERTICAL)
        

        if message:
            top.Add(wxStaticText(self, -1, message), 0,
                    wxALL|wxALIGN_CENTER_VERTICAL, 4)
                    
        if text == "":
            text = "ges. Attribut:"

        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, _(text)), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)

        self.text_attr = wxComboBox(self, -1, "", (0,0), (-1,-1), parameters, wxCB_DROPDOWN )
        box.Add(self.text_attr, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)


        buttons = wxBoxSizer(wxHORIZONTAL)
        button = wxButton(self, wxID_OK, _("OK"))
        buttons.Add(button, 0, wxALL, 4)
        button = wxButton(self, wxID_CANCEL, _("Cancel"))
        buttons.Add(button, 0, wxALL, 4)
        top.Add(buttons, 0, wxALIGN_RIGHT, 4)

        self.SetAutoLayout(1)
        self.SetSizer(top)
        top.Fit(self)
        top.SetSizeHints(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)
        EVT_BUTTON(self, wxID_CANCEL, self.OnCancel)

    def RunDialog(self):
        self.ShowModal()
        self.Destroy()
        return self.result

    def end_dialog(self, result):
        self.result = result
        if result is not None:
            self.EndModal(wxID_OK)
        else:
            self.EndModal(wxID_CANCEL)
        self.Show(False)

    def OnOK(self, event):
        result = {}
        #for name in ("attr"):
        #result[name] = getattr(self, "text_" + name).GetValue()
        result["attr"] = getattr(self, "text_attr").GetValue()
        self.end_dialog(result)

    def OnCancel(self, event):
        self.end_dialog(None)

class diagramm_dialog(wxDialog):
    def __init__(self, parent, parameters, titel, message = "",textKat = "", textAttr = ""):
        wxDialog.__init__(self, parent, -1, titel)
        self.attribute = parameters
        
        
        top = wxBoxSizer(wxVERTICAL)
        

        if message:
            top.Add(wxStaticText(self, -1, message), 0,
                    wxALL|wxALIGN_CENTER_VERTICAL, 4)

        if (textKat == ""):
            textKat = "Menge Kathegorien:"
            
        if (textAttr == "" ):
            textAttr = "ges. Attribut:"

        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, _(textKat)), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)
        self.text_numKath = wxTextCtrl(self, -1)
        
        box.Add(self.text_numKath, 2, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)
        
        

        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, _(textAttr)), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)
        #self.text_attr = wxTextCtrl(self, -1 )
        self.text_attr = wxComboBox(self, -1, "", (0,0), (-1,-1), parameters, wxCB_DROPDOWN )
        box.Add(self.text_attr, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)


        buttons = wxBoxSizer(wxHORIZONTAL)
        button = wxButton(self, wxID_OK, _("OK"))
        buttons.Add(button, 0, wxALL, 4)
        button = wxButton(self, wxID_CANCEL, _("Cancel"))
        buttons.Add(button, 0, wxALL, 4)
        top.Add(buttons, 0, wxALIGN_RIGHT, 4)

        self.SetAutoLayout(1)
        self.SetSizer(top)
        top.Fit(self)
        top.SetSizeHints(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)
        EVT_BUTTON(self, wxID_CANCEL, self.OnCancel)

    def RunDialog(self):
        self.ShowModal()
        self.Destroy()
        return self.result

    def end_dialog(self, result):
        self.result = result
        if result is not None:
            self.EndModal(wxID_OK)
        else:
            self.EndModal(wxID_CANCEL)
        self.Show(False)

    def OnOK(self, event):
        result = {}
        for name in ("numKath", "attr"):
            result[name] = getattr(self, "text_" + name).GetValue()
            
        self.end_dialog(result)

    def OnCancel(self, event):
        self.end_dialog(None)
        
        
class einzelAbfrageDialog(wxDialog):
    def __init__(self, parent, titel, message = "", text = "", defaultWert = ""):
        wxDialog.__init__(self, parent, -1, titel)
        top = wxBoxSizer(wxVERTICAL)
        if message:
            top.Add(wxStaticText(self, -1, message), 0,
                    wxALL|wxALIGN_CENTER_VERTICAL, 4)
                    
        if text == "":
            text = "ges. Attribut:"

        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(wxStaticText(self, -1, _(text)), 0,
                wxALL|wxALIGN_CENTER_VERTICAL, 4)

        self.text_wert = wxTextCtrl(self, -1, defaultWert )
        box.Add(self.text_wert, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)

        buttons = wxBoxSizer(wxHORIZONTAL)
        button = wxButton(self, wxID_OK, _("OK"))
        buttons.Add(button, 0, wxALL, 4)
        button = wxButton(self, wxID_CANCEL, _("Cancel"))
        buttons.Add(button, 0, wxALL, 4)
        top.Add(buttons, 0, wxALIGN_RIGHT, 4)

        self.SetAutoLayout(1)
        self.SetSizer(top)
        top.Fit(self)
        top.SetSizeHints(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)
        EVT_BUTTON(self, wxID_CANCEL, self.OnCancel)

    def RunDialog(self):
        self.ShowModal()
        self.Destroy()
        return self.result

    def end_dialog(self, result):
        self.result = result
        if result is not None:
            self.EndModal(wxID_OK)
        else:
            self.EndModal(wxID_CANCEL)
        self.Show(False)

    def OnOK(self, event):
        result = {}
        result["wert"] = getattr(self, "text_wert").GetValue()
        self.end_dialog(result)

    def OnCancel(self, event):
        self.end_dialog(None)
