from Thuban import _

from voronoi import *
from delaunay import *

from wxPython.wx import *
from utilities import piep

from time import sleep
from thread import *
from shapeStoreZerleger import DiagrammZerleger
from dbFactory import DbFactory
from customLayer import customLayer
# ----------------

diagrammSpeicher = None

class abstrakterDiagrammHalter:
    def __init__(self,diagrammBuilder):
        self.VoronoiDiagrammMap = {}
        self.DelaunayRasterMap = {}
        self.diagrammBuilder = diagrammBuilder
    
    def getVoronoiDiagram( self, layer, rohPunktefeld, bbox, context, annaehern = True ):
        return self.VoronoiDiagrammMap[layer.Title()]
        
    def getDelaunayRaster( self, layer, rohPunktefeld, context ):
        return self.DelaunayRasterMap[layer.Title()]
    
    def setDiagrammBuilder(self,diagrammBuilder):
        self.diagrammBuilder = diagrammBuilder

    def flushDiagramms(self):
        self.VoronoiDiagrammMap = {}
        self.DelaunayRasterMap = {}
    
class diagrammHalter(abstrakterDiagrammHalter):

    def __init__(self,diagrammBuilder=None):
        abstrakterDiagrammHalter.__init__(self,diagrammBuilder)
        
    def getDiagrammHalter():
        global diagrammSpeicher
        if ( diagrammSpeicher == None ):
            diagrammSpeicher = diagrammHalter()
        return diagrammSpeicher
    
    getDiagrammHalter = staticmethod( getDiagrammHalter )
        
    def getVoronoiDiagram( self, layer, rohPunktefeld, bbox, context, annaehern = True ):
        print "- stelle Diagramm bereit"
        diagramm = self._pruefeObVornoiDiagrammVorhanden( layer.Title(),rohPunktefeld,bbox )
        if diagramm == None:
            progressBar = wxProgressDialog(_("Bitte warten"), _("Berechnung des Voronoi Diagramms..."), 100, context.mainwindow, wxPD_AUTO_HIDE)
            self.VoronoiDiagrammMap[layer.Title()] = voronoi_diagram( rohPunktefeld, bbox )
            stopUhr = stopuhr()
            stopUhr.start()
            threadFunc = self.VoronoiDiagrammMap[layer.Title()].start
            identifier = start_new_thread( threadFunc, tuple() )
            while not self.VoronoiDiagrammMap[layer.Title()].istBerechnungAbgeschlossen():
                sleep(.1)
                progressBar.Update( self.VoronoiDiagrammMap[layer.Title()].getProzentFertig() )
            print "- Berechnung dauerte", stopUhr.stop(), "komische zeiteinheiten"
            self.VoronoiDiagrammMap[layer.Title()].begrenzeLinien(annaehern)
            progressBar.Update( 100 )
            progressBar.Destroy()
            diagramm = self.VoronoiDiagrammMap[layer.Title()]
            if isinstance (layer,customLayer):
                if layer.getRollenName() == "pirolDb" and not diagramm.fehlerIstAufgetreten():
                    
                    voroZerleger = DiagrammZerleger(DbFactory.getDbFactory(),diagramm.getKantenfeld(),layer.rolle.gruppenid,"Voronoi",layer.Title(),context.mainwindow)
                    print "-- speichere Voronoi"
                    voroZerleger.save()
                    print "-- Voronoi gespeichert!"
                    piep()
        return diagramm
        
    def _pruefeObVornoiDiagrammVorhanden( self, layerTitel,rohPunktefeld ,bbox):
        resultat = None
        if self.VoronoiDiagrammMap.has_key( layerTitel ) == True and self.VoronoiDiagrammMap[layerTitel].fehlerIstAufgetreten() == False:
            resultat = self.VoronoiDiagrammMap[layerTitel]
        elif self._istDiagrammInDatenbank( layerTitel, true ):
            kantenfeld = self._holeKantenfeldAusDB( layerTitel, true )
            self.VoronoiDiagrammMap[layerTitel] = voronoi_diagram( rohPunktefeld, bbox )
            self.VoronoiDiagrammMap[layerTitel].fuelleDiagrammMitDatenbankDaten( kantenfeld )
            resultat = self.VoronoiDiagrammMap[layerTitel]
        return resultat

    def _istDiagrammInDatenbank( self, titel, istVoronoi):
        """
        hier stellt man fest, ob das entsprechende Diagramm in der DB vorliegt
        titel - primaerer schluessel zum Finden des diagramms
        istVoronoi - bool flag fuer den diagramm typ
        """
        if self.diagrammBuilder == None:
            return False
        print "- vieleicht hat der Diagrammhalter das Diagramm "
        if istVoronoi:
            return self.diagrammBuilder.vorhanden(titel,"Voronoi")
        else:
            return self.diagrammBuilder.vorhanden(titel,"Delaunay")
        
        return False
        
    def _holeKantenfeldAusDB( self, titel, istVoronoi ):
        """
        holt eine Liste mit Kantenobjekten aus der DB
        titel - primaerer schluessel zum Finden des diagramms
        istVoronoi - bool flag fuer den diagramm typ
        """
        if istVoronoi:
            return self.diagrammBuilder.getDiagramm("Voronoi")
        else:
            return self.diagrammBuilder.getDiagramm("Delaunay")
        return None
            
    def getDelaunayRaster( self, layer, rohPunktefeld, context ):
        print "- stelle Raster bereit"
        diagramm = self._pruefeObDelaunayDiagrammVorhanden( layer.Title(), rohPunktefeld)
        if diagramm == None:
            self.DelaunayRasterMap[layer.Title()] = delaunay()
            self.DelaunayRasterMap[layer.Title()].nutzeVorhandenesPunkteFeld(rohPunktefeld)
            progressBar = wxProgressDialog(_("Bitte warten"), _("Berechnung des Delaunay Rasters..."), 100, context.mainwindow, wxPD_AUTO_HIDE)
            stopUhr = stopuhr()
            stopUhr.start()
            threadFunc = self.DelaunayRasterMap[layer.Title()].start
            identifier = start_new_thread( threadFunc, tuple() )
            while not self.DelaunayRasterMap[layer.Title()].istBerechnungAbgeschlossen():
                sleep(.1)
                progressBar.Update( self.DelaunayRasterMap[layer.Title()].getProzentFertig() )
            print "- Berechnung dauerte", stopUhr.stop(), "komische zeiteinheiten"
            progressBar.Update( 100 )
            progressBar.Destroy()
            diagramm = self.DelaunayRasterMap[layer.Title()]
            if isinstance (layer,customLayer):
                print "customLayer %s" %layer.getRollenName()
                if layer.getRollenName() == "pirolDb" and not diagramm.fehlerIstAufgetreten():
                    
                    delaunayKantenfeld = diagramm.getKantenfeld()
                    delaunayZerleger = DiagrammZerleger(DbFactory.getDbFactory(),delaunayKantenfeld,layer.rolle.gruppenid,"Delaunay",layer.Title(),context.mainwindow)
                    print "-- speichere Delaunay"
                    delaunayZerleger.save()
                    print "-- Delaunay gespeichert"
                    piep()            
            
        return diagramm

    def _pruefeObDelaunayDiagrammVorhanden( self, layerTitel,rohPunktefeld ):
        resultat = None
        if self.DelaunayRasterMap.has_key( layerTitel ) == True and self.DelaunayRasterMap[layerTitel].fehlerIstAufgetreten() == False:
            resultat = self.DelaunayRasterMap[layerTitel]
        elif self._istDiagrammInDatenbank( layerTitel, false ):
            kantenfeld = self._holeKantenfeldAusDB( layerTitel, false )
            self.DelaunayRasterMap[layerTitel] = delaunay()
            self.DelaunayRasterMap[layerTitel].nutzeVorhandenesPunkteFeld(rohPunktefeld)
            self.DelaunayRasterMap[layerTitel].fuelleDiagrammMitDatenbankDaten(kantenfeld)
            resultat = self.DelaunayRasterMap[layerTitel]
        return resultat
