from fehler import *
from fehlerhaftesObjekt import *
from feldsortierer import *

# schleifen beschleunigen
try:
    from psyco.classes import __metaclass__
except:
    pass

class diagramm(potentiellFehlerhaftesObjekt):
    def __init__( self ):
        potentiellFehlerhaftesObjekt.__init__(self)
        self.punktefeld = []
        self.kantenfeld = []
        self.debug = False
        self.berechnungAbgeschlossen = False
    
    def start(self ):
        """
        fuehrt eigentliche Berechnung des Diagramms aus, muss in den abgeleiteten Klassen ueberschrieben werden
        """
        return 0
        
    def fuelleDiagrammMitDatenbankDaten( self, kantenfeld ):
        """
        erstellt "voll bestuecktes" Diagramm aus Datenbankdaten, muss in den abgeleiteten Klassen ueberschrieben UND ausgefuehrt werden
        """
        if len( self.punktefeld )==0:
            self.fehler = fehler("Es liegen keine Ausgangspunktedaten vor.")
            return
        print "- speichere Diagramm fuer", len( self.punktefeld ), "Punkte"
        sortierer = feld_sortierer( self.punktefeld )
        self.punktefeld = sortierer.sortiertesFeld()
        
        self.kantenfeld = kantenfeld
        
        self.berechnungAbgeschlossen = True
        
    def istBerechnungAbgeschlossen( self ):
        return (self.berechnungAbgeschlossen or self.fehlerIstAufgetreten())
    
    def getProzentFertig( self ):
        if self.fehlerIstAufgetreten() or self.berechnungAbgeschlossen == True:
            return 100
        return 0
        
    def getGeordnetesPunktefeld( self ):
        return self.punktefeld
        
    def getKantenfeld( self ):
        return self.kantenfeld
