from Thuban.UI.viewport import Tool
from lineTool import LineTool
import os
from Thuban import _
from Thuban.UI.command import registry, ToolCommand

from Thuban.Model.messages import LAYER_PROJECTION_CHANGED, LAYER_VISIBILITY_CHANGED, \
     LAYER_CHANGED, LAYER_SHAPESTORE_REPLACED, CLASS_CHANGED

from utilities import punkt
from customLayer import customLayer
from Thuban.Model.table import *
from data_fake import MemoryShapeStore

import Projection

from time import sleep
from thread import *

from weakref import *

class distanzTool( LineTool ):
    def __init__( self, view, context, findePunktLayer, appAnpasser ):
        LineTool.__init__( self, view )

        self._findePunktLayer = findePunktLayer
        self.appAnpasser = appAnpasser
        self.context = context

        self.layerName = "Distanzen"
        self.layerIstNeu = False

        layer = self._sucheLayer( self.context.mainwindow.canvas.Map() )
        if ( layer == None ):
            self.layerIstNeu = True
            self.storageObjekt = MemoryShapeStore()
            self.storageObjekt.setTable( self._erstelleLeereTabelle() )
            self.layer = customLayer( _(self.layerName), self.storageObjekt)
        else:
            self.layer = layer
            self.storageObjekt = layer.ShapeStore()

    def Name(self):
        return "DistanzWerkzeug"

    def ausgangsPunkt(self):
        if ( self.ersterPunkt != 0 ):
            return self.ersterPunkt
        return None

    def Punkt1( self ):
        return self.ersterPunkt

    def Punkt2( self ):
        return self.zweiterPunkt

    def _berechneEntfernung( self, p1, p2 ):
        distanz = 0.0
        if ( True ):
            # Gauss-Krueger: 1.0 == 1m
            distanz = p1.abstandZu(p2)

        return distanz
        

    def _sucheLayer( self, map ):
        if map.HasLayers() == True:
            for layer in map.layers:
                if ( layer.Title().startswith(self.layerName) and isinstance(layer, customLayer) ):
                    return layer

        # nutze immer das gleiche Layer
        return None

    def _fuegeLinieEinZwischen( self, punkt1, punkt2 ):
        main_window = self.context.mainwindow
        map = main_window.canvas.Map()
        self.appAnpasser.passeAn( self.context.application )

        if map.HasLayers() == True and punkt1 != None and punkt2 != None:
            layerMitPunktdaten = self._findePunktLayer(self.context)

            if layerMitPunktdaten < 0:
                main_window.RunMessageBox(_('missing base data layer'), _('Please add a layer consisting of point data, first'))
                return

            distanz = self._berechneEntfernung( punkt1, punkt2 )

            if ( distanz <= 0.005 ):
                print "distanz:", distanz
                return
            else:
                self.storageObjekt.addLine( [punkt1.x(),punkt2.x()], [punkt1.y(),punkt2.y()] )
                self.storageObjekt.appendAttributeData(  [ distanz ] )

                if ( self.layerIstNeu == True ):
                    map.AddLayer(self.layer)
                    self.context.session.AddShapeStore( self.storageObjekt )
                    self.storageObjekt.bbox = map.layers[layerMitPunktdaten].BoundingBox()
                    
                self.layer.issue(LAYER_CHANGED, self.layer)
                self._resetTool()

    def _erstelleLeereTabelle( self ):
        table = MemoryTable([
                             ("Laenge dieser Strecke (m)", FIELDTYPE_DOUBLE)
                                ],[])
        table.SetTitle( self.layerName )
        return table
        
    def MouseUp(self, event):
        LineTool.MouseUp( self, event )
        self._fuegeLinieEinZwischen( self.ersterPunkt, self.zweiterPunkt )


    def _resetTool( self ):
        self.layerIstNeu = False
        self.ersterPunkt = None
        self.zweiterPunkt = None

