from Thuban.UI.viewport import Tool
from polyTool import polyTool
import os
from Thuban import _
from Thuban.UI.command import registry, ToolCommand

from Thuban.Model.messages import LAYER_PROJECTION_CHANGED, LAYER_VISIBILITY_CHANGED, \
     LAYER_CHANGED, LAYER_SHAPESTORE_REPLACED, CLASS_CHANGED

from utilities import punkt
from customLayer import customLayer
from Thuban.Model.table import *
from data_fake import MemoryShapeStore

#import Projection
import math

from time import sleep
from thread import *



class flaechenTool( polyTool ):
    def __init__( self, view, context, findePunktLayer, appAnpasser ):
        polyTool.__init__( self, view, context, findePunktLayer, appAnpasser )

        self.layerName = "Flaeche Nr. "

        self.storageObjekt.setTable( self._erstelleLeereTabelle() )

    def Name(self):
        return "FlaechenWerkzeug"

    def _trageFlaecheninhaltEin( self, A, table ):
        tabData = table.data
        
        for row in tabData:
            row[3] = A

    def _fuegeLinieEinZwischen( self, event, punkt1, punkt2 ):
        main_window = self.context.mainwindow
        map = main_window.canvas.Map()
        self.appAnpasser.passeAn( self.context.application )

        if map.HasLayers() == True and punkt1 != None and punkt2 != None:
#            if ( self.layerMitPunktdaten < 0 ):
#                self.layerMitPunktdaten = self._findePunktLayer(self.context)
#
#            if self.layerMitPunktdaten < 0:
#                main_window.RunMessageBox(_('missing base data layer'), _('Please add a layer consisting of point data, first'))
#                return

            distanz = self._berechneEntfernung( punkt1, punkt2 )

            if ( distanz <= 0.005 ):
                if ( self.teilstuecke > 0 ):
                    # Schliessen des LinienZuges
                    self.closing = 1
                    self._fuegeLinieEinZwischen( None, self.punkte[ len(self.punkte)-1 ], self.ausgangsPunkt() )
                    A = self._berechneFlaechenInhalt()
                    self._trageFlaecheninhaltEin( A, self.storageObjekt.Table() )
                    print "Flaecheninhalt: A = ", repr(A)
                    self._resetTool()
                else:
                    return
            else:
                self._aktualisiereTeilstuecke(distanz)

                self.storageObjekt.addLine( [punkt1.x(),punkt2.x()], [punkt1.y(),punkt2.y()] )
                self.storageObjekt.appendAttributeData(  [ distanz, self.teilstuecke, self.gesamtLaenge, 0.0 ] )

                if ( self.teilstuecke == 1 ):
                    map.AddLayer(self.layer)
                    self.context.session.AddShapeStore( self.storageObjekt )
                    #self.storageObjekt.bbox = map.layers[self.layerMitPunktdaten].BoundingBox()
                    
                self.layer.issue(LAYER_CHANGED, self.layer)

    def _erstelleLeereTabelle( self ):
        table = MemoryTable([
                             ("Laenge dieser Einzel-Strecke (m)", FIELDTYPE_DOUBLE),
                             ("Index dieses Einzel-Strecke", FIELDTYPE_INT),
                             ("Gesamtlaenge bis einschl. dieses Teilstuecks (m)", FIELDTYPE_DOUBLE),
                             ("Flaecheninhalt d. Polygons (m^2)", FIELDTYPE_DOUBLE)
                                ],[])
        table.SetTitle( self.layerName )
        return table

    def _berechneFlaechenInhalt( self ):
        # gausssche flaechenformel
        A = 0.0

        for i in range( len( self.punkte) ):
            iPlusEins = (i+1)%len(self.punkte)
            if (i-1) < 0:
                iMinusEins = (i-1) + len(self.punkte)
            else:
                iMinusEins = (i-1)

            A += self.punkte[i].x() * ( self.punkte[iPlusEins].y() - self.punkte[iMinusEins].y() )

        A /= 2
        return math.fabs( A )