from Thuban.UI.viewport import Tool
import os
from Thuban import _
from Thuban.UI.command import registry, ToolCommand
from wxPython.wx import *
from Thuban.UI.mainwindow import *
from Thuban.Model.data import *
from Thuban.Model.table import MemoryTable, \
     FIELDTYPE_DOUBLE, FIELDTYPE_INT, FIELDTYPE_STRING

from diagrammDialog import attributAuswahl

from data_fake import *
from shapeStoreVorbereiter import *

from diagrammHalter import diagrammHalter
from customLayer import customLayer, typenMap
from utilities import istZahl

class HoehenlinienTool(Tool):

    def __init__(self, view, context, findePunktLayer, appAnpasser, diagrammSpeicher):
        Tool.__init__(self, view)
        self.context = context

        self._findePunktLayer = findePunktLayer

        self.diagramSpeicher = diagrammSpeicher
        self.appAnpasser = appAnpasser

    def Name(self):
        return "HoehenlinienWerkzeug"
        
    def useAsCommand( self ):
        main_window = self.context.mainwindow
        map = main_window.canvas.Map()
        
        layerUndAttribut = self._erfrageAttribut()
        if ( layerUndAttribut != None ):
            layerMitPunktdaten, attribut = layerUndAttribut
        else:
            return False
        
        diagram_titel = _("Bitte geben Sie den gewuenschten Wert ein")
        text = _("Wert fuer die Aequipotentiallinien")
        message = _("Gesucht ist die Dezimal- oder Kommazahl die das Potential fuer die Linien vorgibt.\nAls Hilfe liefert das Drop-Down-Feld den\nhoechsten und den geringsten Wert des gewaehlten Attributes in diesem Datensatz.\n(bitte geben Sie einen Punkt statt eines Kommas als Trennzeichen fuer Nachkommastellen an.")
        
        colNames = list( map.layers[layerMitPunktdaten].ShapeStore().Table().ValueRange(attribut) )
        for i in range( len(colNames) ):
            colNames[i] = repr( colNames[i] )
        
        v_dialog = attributAuswahl( main_window, colNames, diagram_titel, text=text, message=message )
        userEingabe = v_dialog.RunDialog()
        if userEingabe == None:
            return False

        while not istZahl(userEingabe["attr"]):
            v_dialog = attributAuswahl( main_window, colNames, diagram_titel, text=text, message=message )
            userEingabe = v_dialog.RunDialog()
            
        wert = float( userEingabe["attr"] )
        
        return self._berechneUndZeigeHoehenlinen(  attribut, map, layerMitPunktdaten, wert=wert )
    
    def _erfrageAttribut( self ):
        main_window = self.context.mainwindow
        map = main_window.canvas.Map()

        self.appAnpasser.passeAn( self.context.application )

        if map.HasLayers() == True:
            layerMitPunktdaten = self._findePunktLayer(self.context)

            if layerMitPunktdaten < 0:
                main_window.RunMessageBox(_('missing base data layer'), _('Please add a layer consisting of point data, first'))
                return None

            attrTable = map.layers[layerMitPunktdaten].ShapeStore().Table()
            cols = map.layers[layerMitPunktdaten].ShapeStore().Table().Columns()
            colNames = []

            for i in cols:
                if i.type == FIELDTYPE_INT or i.type == FIELDTYPE_DOUBLE:
                    colNames.append( i.name )

            diagram_titel = "Angaben zu den Hoehenlinien"
            werteSindDiskret = False

            v_dialog = attributAuswahl( main_window, colNames, diagram_titel )
            userEingabe = v_dialog.RunDialog()
            if userEingabe == None:
                return None

            aktCol = attrTable.Column( userEingabe["attr"] )
            if aktCol.type != FIELDTYPE_INT and aktCol.type != FIELDTYPE_DOUBLE:
                werteSindDiskret = True

            while attrTable.HasColumn( userEingabe["attr"] )==False or werteSindDiskret == True:
                werteSindDiskret = False
                if attrTable.HasColumn( userEingabe["attr"] )==False:
                    v_dialog = attributAuswahl( main_window, colNames, dialog_titel, _("dieses Attribut existiert nicht") )
                else:
                    aktCol = attrTable.Column( userEingabe["attr"] )
                    if aktCol.type != FIELDTYPE_INT and aktCol.type != FIELDTYPE_DOUBLE:
                        werteSindDiskret = True
                        v_dialog = attributAuswahl( main_window, colNames, dialog_titel, _("das angegebene Attribut besteht aus diskreten Werten - Interpolation nicht moeglich!") )
                userEingabe = v_dialog.RunDialog()
                        
            return ( layerMitPunktdaten, userEingabe["attr"] )
        
        
    def _berechneUndZeigeHoehenlinen( self, gesuchtesAttribut, map, layerMitPunktdaten, x=None, y=None, wert = None ):
        main_window = self.context.mainwindow
        map = main_window.canvas.Map()
        
        storageObjekt = MemoryShapeStore()
        storageObjekt.bbox = map.layers[layerMitPunktdaten].BoundingBox()

        storeVorbereiter = shapeStoreVorbereiter( map.layers[layerMitPunktdaten].ShapeStore(), storageObjekt )

        storeVorbereiter.setzeAuswertungsAttribut( gesuchtesAttribut )

        Delaunay = self.diagramSpeicher.getDelaunayRaster( map.layers[layerMitPunktdaten], storeVorbereiter.getNormiertesPunktefeld(), self.context )

        if Delaunay.fehlerIstAufgetreten():
            main_window.RunMessageBox(_('Fehler'), _("Es ist der folgende Fehler aufgetreten:\n"+str(Delaunay.getFehler())))
            return False

        if ( wert == None ):
            wert = storeVorbereiter.zeichneHoehenLinien( x=x, y=y, punktefeldEin=Delaunay.getGeordnetesPunktefeld(), kantenfeldEin=Delaunay.getKantenfeld() )
        else:
            storeVorbereiter.zeichneHoehenLinien( punktefeldEin=Delaunay.getGeordnetesPunktefeld(), kantenfeldEin=Delaunay.getKantenfeld(), wert=wert )

        layerName = "Hoehenl. "+gesuchtesAttribut+" "+repr(wert)
        
        # der typ koennte evtl auf "simple" sein - bei extrem grossen datensaetzen koennte 
        # jedoch diese Form der Speicherung Sinn machen
        layer = customLayer( _(layerName), storageObjekt, typ=typenMap.getDelaunayTyp())

        layer.SetClassification(storeVorbereiter.classification)

        storageObjekt.setTitle( layerName )

        map.AddLayer(layer)
        self.context.session.AddShapeStore( storageObjekt )

        self.context.mainwindow.canvas.full_redraw()
        
        return True
        
        

    def MouseUp(self, event):
        Tool.MouseUp(self, event)
        x, y = self.view.win_to_proj(*self.current)
        layerUndAttribut = self._erfrageAttribut()
        if ( layerUndAttribut != None ):
            layerMitPunktdaten, attribut = layerUndAttribut
        else:
            return
        return self._berechneUndZeigeHoehenlinen(  attribut, map, layerMitPunktdaten, x=x, y=y )
# ----------------------------------------------------------
