from Thuban.UI.command import registry, Command, ToolCommand
from Thuban.UI.viewport import Tool, RectTool
from wxPython.wx import *

from Thuban import _
from Thuban.Model.data import *
from Thuban.Model.map import Map
from Thuban.Model.color import Color
from Thuban.UI.mainwindow import *
from Thuban.Model.classification import ClassGroupSingleton, ClassGroupProperties

from diagrammDialog import *
from utilities import *
from linRegression import *
from diagram import *
from data_fake import *

from customLayer import *
from applicationAnpasser import *

from Thuban.Model.table import MemoryTable, \
     FIELDTYPE_DOUBLE, FIELDTYPE_INT, FIELDTYPE_STRING

# ----------------------------------------------------------

class linRegTool(RectTool):

    def __init__(self, view, context, findePunktLayer):
        RectTool.__init__(self, view)
        self.context = context
        self.startX = 0
        self.startY = 0

        self.map = self.context.mainwindow.canvas.Map()
        self.layer = None
        #self.idLayer = None
        self.identified = None

        self.bboxToIdLayer = {}

        self.clusterMacher = None
        self.mapNummerZuShapeId = None
        self.attribute = None

        self._findePunktLayer = findePunktLayer
        self.layerMitPunktdaten = None

        self.diagramme = []

        applicationAnpasser.getApplicationAnpasser().passeAn(context.application)

    def RemoveLayer( self, bboxLayer ):
        try:
            if ( bboxLayer != None ):
                self.map.RemoveLayer( bboxLayer )
            if ( self.bboxToIdLayer.has_key(bboxLayer.getId()) ):
                self.map.RemoveLayer( self.bboxToIdLayer[bboxLayer.getId()] )

                newDict = {}
                for key in self.bboxToIdLayer.keys():
                    if key != bboxLayer.getId():
                        newDict[key] = self.bboxToIdLayer[key]
                self.bboxToIdLayer = newDict
        except:
            print "das layer war wohl schon weg!"


    def Name(self):
        return "LinRegWerkzeug"


    def MouseDown(self, event):
        RectTool.MouseDown(self, event)
        self.startX, self.startY = self.view.win_to_proj(*self.current)

    def MouseUp(self, event):
        #self.RemoveLayer()
        self.idLayer = None
        self.identified = []

        RectTool.MouseUp(self, event)
        x, y = self.view.win_to_proj(*self.current)
        bbox = ( min(x,self.startX), min(y,self.startY), max(x,self.startX), max(y,self.startY) )
        #print bbox
        main_window = self.context.mainwindow
        map = main_window.canvas.Map()
        #print x, y
        if map.HasLayers() == True:
            nummerlayerMitPunktdaten = self._findePunktLayer(self.context)

            if nummerlayerMitPunktdaten < 0:
                main_window.RunMessageBox(_('missing base data layer'), _('Please add a layer consisting of point data, first'))
                return

            self.layerMitPunktdaten = map.layers[ nummerlayerMitPunktdaten ]

            attrTable = self.layerMitPunktdaten.ShapeStore().Table()
            cols = self.layerMitPunktdaten.ShapeStore().Table().Columns()
            colNames = []

            for i in cols:
                if i.type == FIELDTYPE_INT or i.type == FIELDTYPE_DOUBLE:
                    colNames.append( i.name )

            diagram_titel = _("Angaben zur linearen Regression")
            werteSindDiskret = False

            v_dialog = attributAuswahl( main_window, colNames, diagram_titel  )
            userEingabe = v_dialog.RunDialog()
            if userEingabe == None:
                return

            if (attrTable.HasColumn( userEingabe["attr"] )==True ):
                aktCol = attrTable.Column( userEingabe["attr"] )
                if aktCol.type != FIELDTYPE_INT and aktCol.type != FIELDTYPE_DOUBLE:
                    werteSindDiskret = True

            while (attrTable.HasColumn( userEingabe["attr"] )==False or \
                   werteSindDiskret == True ):
                if attrTable.HasColumn( userEingabe["attr"] )==False:
                    v_dialog = attributAuswahl( main_window, colNames, diagram_titel, _("das Attribut existiert nicht") )
                else:
                    if attrTable.Column( userEingabe["attr"] ).type != FIELDTYPE_INT and attrTable.Column( userEingabe["attr"] ).type != FIELDTYPE_DOUBLE:
                        werteSindDiskret = True
                    else:
                        werteSindDiskret = False

                userEingabe = v_dialog.RunDialog()
                if userEingabe == None:
                    return

            # betroffene Punkte ermitteln
            punkteShapefeld = self.layerMitPunktdaten.ShapesInRegion(bbox)

            self.punktefeld = []

            for i in punkteShapefeld:
                Px, Py = i.Points()[0][0]
                # Thuban ist zu ungenau, zweites filtern noetig
                if Px >= bbox[0] and Px <= bbox[2] and Py >= bbox[1] and Py <= bbox[3]:
                    self.punktefeld.append( punkt( [Px, Py], i.ShapeID() ) )

            if len( self.punktefeld ) <= 0:
                print "- keine Punkte im gewaehlten Bereich"
                main_window.RunMessageBox(_('keine Punkte'), _('Keine Punkte im gewaehlten Bereich'))
                return

            # box anzeigen
            storageObjekt = MemoryShapeStore()
            storageObjekt.bbox = bbox

            titel = "lin. Regression fuer "+ str( len(self.punktefeld) ) + " Punkte"

            storageObjekt.setTable( MemoryTable([("Bezeichnung", FIELDTYPE_STRING)],[]) )
            storageObjekt.setTitle( titel )

            # obere Linie
            storageObjekt.addLine( [bbox[0], bbox[2]], [bbox[3],bbox[3]] )
            storageObjekt.appendAttributeData( ["oben"] )
            # rechte Linie
            storageObjekt.addLine( [bbox[2], bbox[2]], [bbox[1],bbox[3]] )
            storageObjekt.appendAttributeData( ["rechts"] )
            # untere Linie
            storageObjekt.addLine( [bbox[0], bbox[2]], [bbox[1],bbox[1]] )
            storageObjekt.appendAttributeData( ["unten"] )
            # linke Linie
            storageObjekt.addLine( [bbox[0], bbox[0]], [bbox[1],bbox[3]] )
            storageObjekt.appendAttributeData( ["links"] )

            self.layer = customLayer( _(titel), storageObjekt)

            self.context.session.AddShapeStore( storageObjekt )
            self.map.AddLayer(self.layer)
            self.map.MoveLayerToBottom(self.layer)
            self.context.mainwindow.canvas.full_redraw()

            # Attributdaten dieser Punkte adaptieren
            #x_attr = []
            #y_attr = []

            # x,y, wert
            werteR = []
            # attr wert
            werteT = []

            self.attribut = userEingabe["attr"]
            diagrammTitel = "lin. Regression fuer "+userEingabe["attr"]

            self.mapNummerZuShapeId = {}

            for i in range( len(self.punktefeld)):
                self.mapNummerZuShapeId[i] = self.punktefeld[i].index
                werteR.append( [self.punktefeld[i].x(), self.punktefeld[i].y(), 1.0] )
                werteT.append( [attrTable.ReadValue( self.punktefeld[i].index, self.attribut )] )

            self.regression = linRegression( werteR, werteT )

            if self.regression.fehlerIstAufgetreten() == False:
                werteTupel = self.regression.fuehreLinieareRegressionDurch()
            else:
                main_window.RunMessageBox(_('Fehler bei der linearen Regression'), _(str(self.regression.fehler)))
                print "- Abbruch:", self.regression.fehler
                self.map.RemoveLayer(self.layer)
                return

            print "werteTupel:", werteTupel
            a = []

            for wrt in werteTupel:
                a.append( float(wrt) )

            print a



            #anzeiger = allgTabellenAnzeige( self.main_window, [[ alpha ],[ str(round(varianzAnalyse.getPruefsumme(),5))[:8] ], [str(round(varianzAnalyse.signifikanzZurPruefsumme(),5))[:8]], [str(varianzAnalyse.getXYFreiheitsgrade())], [gleichheitWiderlegt ]], [ "Signifikanz", "Pruefsumme T(n)", "P(T(n)>f)", "Freiheitsgrade", "Gleichh.d.Var. widerlegt" ], ["wert"], "Varianz Analyse", tool=self )
            #anzeiger.RunDialog()

            #diagramMaler = linReg_diagramZeichner( main_window, _(diagrammTitel), ((self.clusterMacher.mins[0],self.clusterMacher.maxs[0]), (self.clusterMacher.mins[1],self.clusterMacher.maxs[1])), self.clusterMacher.getGeclustertesPunktefeld(), self.clusterMacher.getClusterzentren(), [userEingabe["xattr"],userEingabe["yattr"]], self, fuzzy = self.clusterMacher.getStaerkeDerFuzzyfizierung()  )
            #diagramMaler.RunDialog()
#            self.diagramme.append( diagramMaler )
#            print "done"
            piep()



# ----------------------------------------------------------
