from diagram import *

class linReg_diagramZeichner(diagramZeichner):

    def __init__( self, parent, titel, Range, punktefeld, clusterZentren, achsenNamen=[], tool=None, fuzzy=0 ):
        """
        parent - parent-Fenster
        titel  - Diagramm-Titel
        Range  - tuple( (minx, maxx),(miny,maxy) ) 
        """
        
        diagramZeichner.__init__( self, parent, titel )
        
        self.malflaeche.parent = self
        self.tool = tool
        self.bboxLayer = self.tool.layer
        
        self.hoehe = 0
        self.breite = 0
        
        self.menge = len( punktefeld )
        self.fuzzyStaerke = fuzzy
        
        self.xRange, self.yRange = Range
        self.ySteps = 10.0
        
        self.xSteps = 10.0
        self.punktefeld = punktefeld
        self.clusterZentren = clusterZentren
        
        self.maxPunktDurchm = 10
        self.diagrammBreite = 0
        
        self.nullPunkt = (0,0)
        
        # Bezeichnungen
        self.xAchse = "X"
        self.yAchse = "Y"
        
        self.farben = []
        
        if len(self.clusterZentren) > 1:
            colorStep = int( 255 / (len(self.clusterZentren)-1) )
        else:
            colorStep = 255
        for i in range( len(self.clusterZentren) ):
            self.farben.append( wxColour( colorStep * i, 0, 255 - (colorStep * i) ) )
        
        if achsenNamen!=[]:
            self.xAchse = achsenNamen[0][:10]
            self.yAchse = achsenNamen[1][:7]
        
    def setzteNullpunkt( self, breite, hoehe ):
        #self.nullPunkt = ( int(breite*0.9), int(hoehe*0.9) )
        self.nullPunkt = ( int(breite*0.1), int(hoehe*0.83) )
        self.diagrammBreite = breite*0.78
        self.diagrammHoehe = hoehe*0.78
        self.maxPunktDurchm = int( round(self.diagrammBreite / 35)  )
        if self.maxPunktDurchm > 30:
            self.maxPunktDurchm = 30
        elif self.maxPunktDurchm < 4:
            self.maxPunktDurchm = 4
            
    def rechnePunktUm( self, punkt ):
        x, y = punkt
        nullX, nullY = self.nullPunkt
        return ( nullX + x, nullY - y )
        
    def rechneXKoordUm( self, x ):
        nullX, nullY = self.nullPunkt
        return int(nullX + x)
        
    def rechneYKoordUm( self, y ):
        nullX, nullY = self.nullPunkt
        return int(nullY - y)
        
    def zeichnePunkte( self, memoryDC ):
        for i in range( len( self.punktefeld ) ):
            self.zeichneEinenPunkt( memoryDC, self.punktefeld[i] )
            
        for i in range( len( self.clusterZentren ) ):
            self.zeichneEinZentrum( memoryDC, self.clusterZentren[i], i )
            
    def identifiziereObjektAn( self, x, y ):
        #print "identifiziereObjektAn", x, y
        mouse = punkt([x,y])
        xAnfang, xEnde = self.xRange
        yAnfang, yEnde = self.yRange
        xSpanne = xEnde - xAnfang
        ySpanne = yEnde - yAnfang
        
        zutreffendesZentrum = None
        
        for zentrum in self.clusterZentren:
            zentrumX = self.rechneXKoordUm( (1.0* (zentrum.koord[0] - xAnfang) /  xSpanne) * self.diagrammBreite)
            zentrumY = self.rechneYKoordUm( (1.0* (zentrum.koord[1] - yAnfang) /  ySpanne) * self.diagrammHoehe)
            tmp = punkt( [zentrumX, zentrumY] )
            abstand = tmp.abstandZu( mouse )
            if ( abstand <= self.maxPunktDurchm/2 ):
                zutreffendesZentrum = zentrum
                print "clusterZentrum (", str( self.clusterZentren.index(zentrum) ), "):", zentrum, ", mouse an:", mouse
                break
        if ( zutreffendesZentrum == None ):
            return None
        
        indexeUndZugehoerigePunkte = {}
        
        for i in range( len( self.punktefeld ) ):
            if ( self.punktefeld[i].GetPrimaereZugehoerigkeit() == zutreffendesZentrum.index ):
                indexeUndZugehoerigePunkte[ i ] = self.punktefeld[i]
            
        self.tool.identifizierePunkte( zutreffendesZentrum.index, indexeUndZugehoerigePunkte, self.farben[zutreffendesZentrum.index], self.bboxLayer.getId() )
        
    def zeichneEinZentrum( self, memoryDC, punkt, nummer ):
        xAnfang, xEnde = self.xRange
        yAnfang, yEnde = self.yRange
        xSpanne = xEnde - xAnfang
        ySpanne = yEnde - yAnfang

        x = (1.0* (punkt.koord[0] - xAnfang) /  xSpanne) * self.diagrammBreite
        y = (1.0* (punkt.koord[1] - yAnfang) /  ySpanne) * self.diagrammHoehe
        
        #memoryDC.SetBrush( wxBrush(wxColour(255,0,0), wxSOLID) )
        hoechsterWert = 0
        farbWert = self.farben[nummer]
        
        alteFont = memoryDC.GetFont()
        alterSchriftBg = memoryDC.GetTextBackground()
        neueFont = wxFont( weight = wxNORMAL, pointSize = 9, family = wxDEFAULT, style = wxNORMAL )
        punktKoordinaten = str(punkt)
        
        
        
        alterPen = memoryDC.GetPen()
        neuerPen = wxPen( farbWert, 3 )
        dickerSchwarzerPen = wxPen( wxColour(0,0,0), 5 )
        dickerWeisserPen = wxPen( wxColour(255,255,255), 7 )

        memoryDC.SetPen( alterPen )
        memoryDC.SetFont( neueFont )
        memoryDC.SetTextBackground(farbWert)
        memoryDC.SetTextForeground(wxColour(255,255,255) )
        memoryDC.SetBackgroundMode( wxSOLID )
        
        breite, hoehe = memoryDC.GetTextExtent(punktKoordinaten)
        memoryDC.DrawText( punktKoordinaten, self.rechneXKoordUm(self.diagrammBreite-breite), self.rechneYKoordUm(self.diagrammHoehe-(nummer*hoehe)) )
        
        memoryDC.SetFont( alteFont )
        memoryDC.SetTextForeground(wxColour(0,0,0) )
        memoryDC.SetTextBackground(alterSchriftBg)
        memoryDC.SetBackgroundMode( wxTRANSPARENT )
        
        if self.menge > 100:
            memoryDC.SetPen( dickerWeisserPen )
            memoryDC.DrawLine( self.rechneXKoordUm(x), self.rechneYKoordUm(y+self.maxPunktDurchm/2), self.rechneXKoordUm(x), self.rechneYKoordUm(y-self.maxPunktDurchm/2) )
            memoryDC.DrawLine( self.rechneXKoordUm(x+self.maxPunktDurchm/2), self.rechneYKoordUm(y), self.rechneXKoordUm(x-self.maxPunktDurchm/2), self.rechneYKoordUm(y) )
            
        
        memoryDC.SetPen( dickerSchwarzerPen )
        memoryDC.DrawLine( self.rechneXKoordUm(x), self.rechneYKoordUm(y+self.maxPunktDurchm/2), self.rechneXKoordUm(x), self.rechneYKoordUm(y-self.maxPunktDurchm/2) )
        memoryDC.DrawLine( self.rechneXKoordUm(x+self.maxPunktDurchm/2), self.rechneYKoordUm(y), self.rechneXKoordUm(x-self.maxPunktDurchm/2), self.rechneYKoordUm(y) )
        
        memoryDC.SetPen( neuerPen )
        memoryDC.DrawLine( self.rechneXKoordUm(x), self.rechneYKoordUm(y+self.maxPunktDurchm/2), self.rechneXKoordUm(x), self.rechneYKoordUm(y-self.maxPunktDurchm/2) )
        memoryDC.DrawLine( self.rechneXKoordUm(x+self.maxPunktDurchm/2), self.rechneYKoordUm(y), self.rechneXKoordUm(x-self.maxPunktDurchm/2), self.rechneYKoordUm(y) )

        
    
    def zeichneEinenPunkt( self, memoryDC, punkt ):
        xAnfang, xEnde = self.xRange
        yAnfang, yEnde = self.yRange
        xSpanne = xEnde - xAnfang
        ySpanne = yEnde - yAnfang

        #print "zeichne", punkt

        x = (1.0* (punkt.koord[0] - xAnfang) /  xSpanne) * self.diagrammBreite
        y = (1.0* (punkt.koord[1] - yAnfang) /  ySpanne) * self.diagrammHoehe
        
        #memoryDC.SetBrush( wxBrush(wxColour(255,0,0), wxSOLID) )
        hoechsterWert = 0
        farbindex = 0
        for i in range( len(self.clusterZentren) ):
            if hoechsterWert < punkt.GetZugehoerigkeit( i ):
                hoechsterWert = punkt.GetZugehoerigkeit( i )
                farbindex = i
        
        neuerPen = wxPen( wxColour(0,0,0), 1 )        
        memoryDC.SetPen( neuerPen )
                
        memoryDC.SetBrush( wxBrush(self.farben[farbindex], wxSOLID) )
        
        memoryDC.DrawCircle( self.rechneXKoordUm(x), self.rechneYKoordUm(y), int(self.maxPunktDurchm/2) )
        
        
        startWinkel = 0
        endWinkel = 90 
        for i in range( len(self.clusterZentren) ):
            if i == farbindex:
                continue
            if punkt.GetZugehoerigkeit( i ) >= 0.01:
                startWinkel = endWinkel
                endWinkel += int(360 * punkt.GetZugehoerigkeit( i ))
                memoryDC.SetBrush( wxBrush(self.farben[i], wxSOLID) )
                memoryDC.DrawEllipticArc( self.rechneXKoordUm(x-self.maxPunktDurchm/2), self.rechneYKoordUm(y+self.maxPunktDurchm/2), self.maxPunktDurchm, self.maxPunktDurchm, startWinkel, endWinkel )
        
        memoryDC.SetBrush(wxBrush(wxColour(0,0,0), wxTRANSPARENT))

    def zeichneAchsen( self, memoryDC ):
        xAnfang, xEnde = self.xRange
        yAnfang, yEnde = self.yRange
        xSpanne = xEnde - xAnfang
        ySpanne = yEnde - yAnfang
        xStep = 1.0*xSpanne/self.xSteps
        yStep = 1.0*ySpanne/self.ySteps
        
        
        x_Step = 1.0 * self.diagrammBreite/self.xSteps
        y_Step = 1.0 * self.diagrammHoehe/self.ySteps
            
        memoryDC.SetBrush(wxBrush(wxCYAN, wxTRANSPARENT))
        memoryDC.SetPen(wxPen(wxBLACK, 2, wxSOLID))
        # X
        memoryDC.DrawText( self.xAchse, self.rechneXKoordUm(self.diagrammBreite-20), self.rechneYKoordUm(-20) )
        memoryDC.DrawLine( self.rechneXKoordUm(0), self.rechneYKoordUm(0), self.rechneXKoordUm(self.diagrammBreite), self.rechneYKoordUm(0))
        
        for i in range( int(self.xSteps) ):
            memoryDC.DrawLine( self.rechneXKoordUm(i*x_Step), self.rechneYKoordUm(-3), self.rechneXKoordUm(i*x_Step), self.rechneYKoordUm(3))
            xZahl = repr(1.0*xAnfang+i*xStep)
            xZahl = xZahl[:5]
            xText = xZahl

            memoryDC.DrawRotatedText( xText, self.rechneXKoordUm(i*x_Step+5), self.rechneYKoordUm(-10), 270 )
        
        endPunkte = [ (self.rechneXKoordUm(self.diagrammBreite), self.rechneYKoordUm(-3)),  (self.rechneXKoordUm(int(self.diagrammBreite)), self.rechneYKoordUm(3)), (self.rechneXKoordUm(self.diagrammBreite+10), self.rechneYKoordUm(0)), (self.rechneXKoordUm(self.diagrammBreite), self.rechneYKoordUm(-3))]
        memoryDC.DrawPolygon( endPunkte )
        
        # Y
        memoryDC.DrawText( self.yAchse, self.rechneXKoordUm(-45), self.rechneYKoordUm(self.diagrammHoehe) )
        memoryDC.SetBrush(wxBrush(wxCYAN, wxTRANSPARENT))
        memoryDC.SetPen(wxPen(wxBLACK, 2, wxSOLID))
        memoryDC.DrawLine( self.rechneXKoordUm(0), self.rechneYKoordUm(0), self.rechneXKoordUm(0), self.rechneYKoordUm(self.diagrammHoehe))
        
        for i in range( int(self.ySteps) ):
            memoryDC.DrawLine( self.rechneXKoordUm(-3), self.rechneYKoordUm(i*y_Step), self.rechneXKoordUm(3), self.rechneYKoordUm(i*y_Step))
            yZahl = repr(1.0*yAnfang+i*yStep)
            yZahl = yZahl[:5]
            yText = yZahl
            memoryDC.DrawText( yText, self.rechneXKoordUm(-40), self.rechneYKoordUm(i*y_Step+7) )
            
        endPunkte = [ (self.rechneXKoordUm(-3), self.rechneYKoordUm(self.diagrammHoehe)),  (self.rechneXKoordUm(3), self.rechneYKoordUm(self.diagrammHoehe)), (self.rechneXKoordUm(0), self.rechneYKoordUm(self.diagrammHoehe+10)), (self.rechneXKoordUm(-3), self.rechneYKoordUm(self.diagrammHoehe))]
        memoryDC.DrawPolygon( endPunkte )
        
        memoryDC.SetBrush(wxBrush(wxCYAN, wxTRANSPARENT))
        memoryDC.SetPen(wxPen(wxBLACK, 2, wxSOLID))
        
    def zeichneDaten( self, memoryDC ):
        schriftHoehe = 15
        trennerSchritt = int(schriftHoehe+schriftHoehe/2)
        
        xAnfang, xEnde = self.xRange
        yAnfang, yEnde = self.yRange
        
        bezeichner = [ "Menge:", "Num.Cluster:", "min.Wert X:", "max.Wert X:", "min.Wert Y:", "max.Wert Y:" ]
        werte = [ self.menge, len(self.clusterZentren), xAnfang, xEnde, yAnfang, yEnde ]
        
        if self.fuzzyStaerke >= 1:
            bezeichner.append( "Fuzzyfiz.:")
            werte.append( self.fuzzyStaerke )
        
        for i in range( min( len(bezeichner), len(werte) ) ):
            memoryDC.DrawText( bezeichner[i], self.rechneXKoordUm(self.diagrammBreite), self.rechneYKoordUm(self.diagrammHoehe-(i*2*schriftHoehe)-(int(i/2)*trennerSchritt)) )
            text = str(repr(werte[i]))
            text = text[:5]
            memoryDC.DrawText( text, self.rechneXKoordUm(self.diagrammBreite), self.rechneYKoordUm(self.diagrammHoehe-((i*2+1)*schriftHoehe)-(int(i/2)*trennerSchritt)) )
        
        
    def zeichneAufBuffer( self, memoryDC ):
        try:
            if memoryDC==None:
                print "keine DC!!"
                return False
            memoryDC.BeginDrawing()

            # Clear everything
            memoryDC.SetBrush(wxBrush(wxWHITE, wxSOLID))
            memoryDC.Clear()

            # zeichne Rahmen
            self.breite, self.hoehe = memoryDC.GetSizeTuple()
            self.setzteNullpunkt( self.breite, self.hoehe )
            memoryDC.SetBrush(wxBrush(wxCYAN, wxTRANSPARENT))
            memoryDC.SetPen(wxPen(wxBLACK, 2, wxSOLID))
            memoryDC.DrawRectangle(5, 5, self.breite-10, self.hoehe-10)
            
            self.zeichnePunkte( memoryDC )
            self.zeichneAchsen( memoryDC )
            self.zeichneDaten( memoryDC )

            memoryDC.EndDrawing()
            return True

        except:
            return False

    def end_dialog(self):
        if self.tool != None:
            self.tool.RemoveLayer(self.bboxLayer)
        diagramZeichner.end_dialog(self)