from Thuban.UI.viewport import Tool
import os
from Thuban import _
from Thuban.UI.command import registry, ToolCommand

from utilities import punkt

class LineTool( Tool ):
    def __init__( self, view ):
        Tool.__init__( self, view )
        self.ersterPunkt = None
        self.zweiterPunkt = None
        
        self.dc = None

    def drag_start(self, _x, _y):
        if ( self.dragging == 0 ):
            Tool.drag_start( self, _x, _y )
            x, y = self.view.win_to_proj(*self.current)
            self.ersterPunkt = punkt( [x,y] )

    def drag_stop(self, _x, _y):
        if ( self.dragging != 0 ):
            Tool.drag_stop( self, _x, _y )

    def drag_move(self, _x, _y):
        if ( self.dragging != 0 ):
            Tool.drag_move( self, _x, _y )
            x, y = self.view.win_to_proj(*self.current)
            self.zweiterPunkt = punkt( [x,y] )


    def draw(self, dc):
        if ( dc != None ):
            self.dc = dc
            cx, cy = self.current
            if ( self.ersterPunkt != None and self.zweiterPunkt != None ):
                x1, y1 = self.view.proj_to_win( self.ersterPunkt.x() ,self.ersterPunkt.y())
                dc.DrawLine( int(x1), int(y1), int(cx), int(cy) )


    def MouseDown(self, event):
        self.drag_start(event.m_x, event.m_y)

    def MouseUp(self, event):
        self.drag_stop(event.m_x, event.m_y)
        x, y = self.view.win_to_proj(*self.current)
        self.zweiterPunkt = punkt( [x,y] )
