from Thuban.UI.viewport import *
from utilities import istZahl
from Thuban import _
from diagrammDialog import *
from Thuban.Model.table import MemoryTable, \
     FIELDTYPE_DOUBLE, FIELDTYPE_INT, FIELDTYPE_STRING
     
from Thuban.Model.classification import ClassGroupSingleton, ClassGroupProperties
     
from customLayer import customLayer

from Thuban.Model.color import *
import random

class rasterAttributTool(IdentifyTool):
    def __init__(self, view, context, findeRasterLayer, appAnpasser, _versucheZuParsen ):
        IdentifyTool.__init__(self,view)
        random.seed()
        
        self.context = context
        self.findeRasterLayer = findeRasterLayer
        self._versucheZuParsen = _versucheZuParsen
        self.appAnpasser = appAnpasser
        
        main_window = context.mainwindow
        map = main_window.canvas.Map()
        
        self.attr = ""
        self.wert = None
        
        self.gesperrt = False

        rasterLayerIndex = self.findeRasterLayer(context)
        
        if ( rasterLayerIndex > -1 ):
            self.rasterLayer = map.layers[rasterLayerIndex]

            if ( not self._erfrageWert() ):
                main_window = self.context.mainwindow
                main_window.RunMessageBox(_('kein Attribut gesetzt'), _('Es wurde kein Attribut gewaehlt, starten Sie das Tool neu.'))
                self.gesperrt = True
                return

                
            
            classif = self.rasterLayer.GetClassification()
            akt = None
            
            removed = 0
            for i in range(classif.GetNumGroups()):
                akt = classif.GetGroup( i-removed )
                if ( akt.GetLabel().find( "Attr" ) != 0 ):
                    classif.RemoveGroup( i-removed )
                    removed += 1
            
            self.rasterLayer.SetClassificationColumn(self.attr)
            classif.SetDefaultFill( Color(.0,1.,.0 ) )
            
            print "classif:", classif
            
            properties = ClassGroupProperties()
            properties.SetFill( Color(random.random(),random.random(),random.random()) )
            
            classif.AppendGroup( ClassGroupSingleton( value = self.wert, props = properties, label = "Attr.:"+self.attr+" "+str(self.wert), group = None) )
        else:
            self.rasterLayer = None
            print "kein Raster-Layer gefunden!"
   
    def Name( self ):
        return "Raster Attribut Tool"

   
    def _erfrageWert( self ):
        main_window = self.context.mainwindow
        map = main_window.canvas.Map()
        
        attrTable = self.rasterLayer.ShapeStore().Table()
        cols = attrTable.Columns()
        colNames = []

        for i in cols:
            colNames.append( i.name )

        dialog_titel = _("Angaben zu aendernden Attribut")
        v_dialog = diagramm_dialog( main_window, colNames, dialog_titel,textKat = "neuer Wert", textAttr = "Attribut" )
        userEingabe = v_dialog.RunDialog()

        if userEingabe == None:
            return False

        aktCol = attrTable.Column( userEingabe["attr"] )
        if aktCol.type != FIELDTYPE_INT and aktCol.type != FIELDTYPE_DOUBLE:
            werteSindDiskret = True

        while attrTable.HasColumn( userEingabe["attr"] )==False or (istZahl(userEingabe["numKath"])==False and werteSindDiskret != True):
            if attrTable.HasColumn( userEingabe["attr"] )==False:
                v_dialog = diagramm_dialog( main_window, colNames, dialog_titel, _("dieses Attribut existiert nicht - fuegen Sie es ggf. hinzu."),textKat = "neuer Wert", textAttr = "Attribut" )
            else:
                aktCol = attrTable.Column( userEingabe["attr"] )
                if aktCol.type != FIELDTYPE_INT and aktCol.type != FIELDTYPE_DOUBLE:
                    werteSindDiskret = True
            if istZahl(userEingabe["numKath"])==False and werteSindDiskret != True:
                v_dialog = diagramm_dialog( main_window, colNames, dialog_titel, _("bitte geben Sie eine Zahl ein"),textKat = "neuer Wert", textAttr = "Attribut" )

            userEingabe = v_dialog.RunDialog()
            if userEingabe == None:
                return False
                
        self.attr = userEingabe["attr"]
        self.wert = self._versucheZuParsen( aktCol.type, userEingabe["numKath"] )
        return True
        
    def MouseUp(self, event):
        if ( self.gesperrt == True ):
            return
            
        IdentifyTool.MouseUp(self, event)
        layer, shape = self.view.find_shape_at( event.m_x, event.m_y, searched_layer = self.rasterLayer)
        
        if ( shape != None and isinstance( layer, customLayer) and layer.eindeutigeID==self.rasterLayer.eindeutigeID):
            main_window = self.context.mainwindow
            self.rasterLayer.ShapeStore().setAttributeValue( shape, self.attr, self.wert )
            main_window.canvas.full_redraw()
            
