from Thuban.UI.viewport import *
from utilities import istZahl
from Thuban import _
from diagrammDialog import *
from Thuban.Model.table import MemoryTable, \
     FIELDTYPE_DOUBLE, FIELDTYPE_INT, FIELDTYPE_STRING
     
from Thuban.Model.classification import ClassGroupSingleton, ClassGroupProperties
     
from customLayer import customLayer

from Thuban.Model.color import *

class rasterZellenLoeschenTool(IdentifyTool):
    def __init__(self, view, context, findeRasterLayer, appAnpasser ):
        IdentifyTool.__init__(self,view)
        
        self.context = context
        self.findeRasterLayer = findeRasterLayer
        self.appAnpasser = appAnpasser
        
        main_window = context.mainwindow
        map = main_window.canvas.Map()
        
        self.attr = ""
        self.wert = None

        rasterLayerIndex = self.findeRasterLayer(context)
        
        if ( rasterLayerIndex > -1 ):
            self.rasterLayer = map.layers[rasterLayerIndex]

            classif = self.rasterLayer.GetClassification()
            classif.SetDefaultFill( Color(.0,1.,.0 ) )
            
            if ( len(self.attr) > 0 and self.attr != ""):
                # falls spaeter benoetigt...
                self.rasterLayer.SetClassificationColumn(self.attr)
                
            
        else:
            self.rasterLayer = None
            print "kein Raster-Layer gefunden!"
   
    def Name( self ):
        return "Raster Zellen Loeschen Tool"

   
    def MouseUp(self, event):
        #IdentifyTool.MouseUp(self, event)
        layer, shape = self.view.find_shape_at( event.m_x, event.m_y, searched_layer = self.rasterLayer)
        
        if ( shape != None and self.rasterLayer != None and isinstance( layer, customLayer) and layer.eindeutigeID==self.rasterLayer.eindeutigeID):
            main_window = self.context.mainwindow
            shapeObjekt = self.rasterLayer.ShapeStore().Shape(shape)
            if ( shapeObjekt != None ):
                self.rasterLayer.ShapeStore().RemoveShape( shapeObjekt )
                main_window.canvas.full_redraw()
            
