from derivedTables import *
from logger import Logger
from dbFactory import DbFactory
from mx.DateTime import *
datetime = DateTime

from data_fake import *

from __future__ import generators

from Thuban.Model import wellknowntext
from Thuban.Model.postgisdb import PostGISShape
from Thuban.Model.table import *
from utilities import kante,punkt

#Dialogs
from LoadDialog import loadDialog

from time import sleep
from wxPython.wx import *

from thread import *

# schleifen beschleunigen
try:
    from psyco.classes import __metaclass__
except:
    pass

class DiagrammBuilder:
    def __init__(self,dbfact,mwindow):
        self.dbfact=dbfact
        self.diagramms = {}
        self.mwindow = mwindow
    def vorhanden(self,name,typ):
        # hole den Typ des Diagramms in der db
        
        if self.diagramms.has_key(typ) and len(self.diagramms[typ])!=0:
            return True
        else:
            print "-- DiagrammBuilder: hole Diagramm aus DB"
            threadfunc = self.dbfact.dbDiagrammFromName
            self.dbfact.fertig=False
            identifier = start_new_thread(threadfunc,(name,typ))
                        
            progressBar = wxProgressDialog("Bitte warten", "Diagramm wird aus DB geladen ...", 100, self.mwindow, wxPD_AUTO_HIDE)
            while not self.dbfact.Fertig():
                sleep(0.1)
                progressBar.Update( int(self.dbfact.getPercent()) )
        
            progressBar.Update(100)
            self.dbfact.fertig=False
            diagramms = self.dbfact.result
            
            
            if len (diagramms) == 0:
                return False
            
            self.diagramms[typ]=self._parsedbDiagramms(diagramms)
            return True
                
    def _parsedbDiagramms(self,dbDiagramms):
        kantenliste = []
        for entry in dbDiagramms:
            
            points = wellknowntext.parse_wkt_thuban(entry.geomkante)
            x1 = repr(points[0][0][0])
            y1 = repr(points[0][0][1])
            x2 = repr(points[0][1][0])
            y2 = repr(points[0][1][1])
            pktlinks = entry.pktlinks
            pktrechts = entry.pktrechts
            k = kante(float(x1),float(y1),float(x2),float(y2),pktrechts,pktlinks)
            kantenliste.append(k)
        return kantenliste

    def getDiagramm(self,typ):
        retval = self.diagramms[typ]
        self.diagramms[typ]=[]
        del self.diagramms[typ]
        return retval
        



    
class PirolShapeFileShape(PostGISShape):
    def __init__(self,shapeid,data):
        PostGISShape.__init__(self,shapeid,data)
    
    
    
    def isInRegion(self, bbox):
        ThisMinX, ThisMinY, ThisMaxX, ThisMaxY = bbox
        minX, minY, maxX, maxY = self.compute_bbox()
        
        if minX >= ThisMinX and minX <= ThisMaxX and minY >= ThisMinY and minY <= ThisMaxY:
            return True
        if maxX >= ThisMinX and maxX <= ThisMaxX and maxY >= ThisMinY and maxY <= ThisMaxY:
            return True
        isInRegion = False
        #print self.Points()
        for shape in self.Points():
            for part in shape:
                x, y = part
                if (x >= minX and x <= maxX) and (y >= minY and y <= maxY):
                    isInRegion = True
                    break

        return isInRegion
    
    

class PriolShapeStore(MemoryShapeStore_Interface):
    def __init__(self, dbconn):
        MemoryShapeStore_Interface.__init__(self)
        self.shapesList=[]
        self.dbconn = dbconn
        self.numshapes=0
        self.table=None
        self.bbox=None
        self.shapeStoreName=""
        self.gruppenid=None
    
    def DBConnection( self ):
        return self.dbconn
    
    def addShape(self,data):
        newIndex = len( self.shapesList ) 
        newPoint = PirolShapeFileShape(newIndex,data)
        self.shapesList.append(newPoint)
        self.numshapes = len(self.shapesList)
        return newIndex
    
    def BoundingBox(self):
        return self.compute_bbox()

    def ShapesInRegion(self,bbox):
        for i in range(self.numshapes):
            if self.shapesList[i].isInRegion(bbox) :
                yield ( self.shapesList[i] )
    
    def AllShapes(self):
        print "Numshapes %d" %self.numshapes
        for i in range(self.numshapes ):
            yield (self.shapesList[i])
    
    def Shape(self,index):
        return self.shapesList[index]
    
    def compute_bbox(self):
        xs=[]
        ys=[]
        for shape in self.AllShapes():
            for part in shape.Points():
                for x,y in part:
                    xs.append(x)
                    ys.append(y)
        
        return  (min(xs),min(ys),max(xs),max(ys)) 

class ShapeStoreBuilder:
    
    
    def __init__(self,dbfact,wxparent,schlagid=None,gruppenid=None,tiefen=None):
        self.dbfact=dbfact
        self.StorageObject=None
        self.wxparent = wxparent
        self.schlagChoise = schlagid
        self.gruppenChoise = gruppenid
        self.tiefenChoise = tiefen
    

    def RunDialog(self,name,args=None):
        
        par = self.wxparent
        evalstring = "%s(par,args)"%name
        dlg = eval(evalstring)
        return dlg.RunDialog()
            
    
    def getShapeStore(self):
        #zuerst muss der User einen Schlag waehlen
        store = PriolShapeStore(self.dbfact.db.postGisConn)
        
        self.dbfact.fertig = False
        if self.gruppenChoise==None :
            # dann muessen wir den Dialog feuern
            retval = self.RunDialog("loadDialog")
            if (retval == None):
                return
                
            schlag,gruppen,tiefen=retval
            store.gruppenid = int(gruppen[0].gruppenid)
            
            self.schlagChoise = schlag.pkid[0]
            self.gruppenChoise = gruppen[0].gruppenid
            self.tiefenChoise = [i.tiefenid for i in  tiefen]
            
            
            progressBar = wxProgressDialog("Bitte warten", "Layer wird aus DB geladen ...", 100, self.wxparent, wxPD_AUTO_HIDE)
            threadfunc = self.dbfact.getDataFromGroup
            
            
            identifier = start_new_thread(threadfunc,(gruppen[0].gruppenid,[i.tiefenid for i in  tiefen],store))
            while not self.dbfact.Fertig():
                sleep(0.1)
                progressBar.Update( int(self.dbfact.getPercent()) )
            progressBar.Update( 100 )
            self.dbfact.fertig=False
            
            store.shapeStoreName="%s, %s"%(schlag.name,gruppen[0].name)
        else:
            
            progressBar = wxProgressDialog("Bitte warten", "Layer wird aus DB geladen ...", 100, self.wxparent, wxPD_AUTO_HIDE)
            threadfunc = self.dbfact.getDataFromGroup
            if (self.tiefenChoise != None):
                identifier = start_new_thread(threadfunc,(self.gruppenChoise,None,store))
            else:    
                identifier = start_new_thread(threadfunc,(self.gruppenChoise,self.tiefenChoise,store))
                
            while not self.dbfact.Fertig():
                sleep(0.1)
                progressBar.Update( int(self.dbfact.getPercent()) )
            progressBar.Update( 100 )
            self.dbfact.fertig=False
            #self.dbfact.getDataFromGroup(self.gruppenChoise,None,store)
            store.shapeStoreName="Temporary"
        
    
        return store
    
    
    
    
    
    
    
    
    
    
    