from derivedTables import *
from logger import Logger
from dbFactory import *
#from datetime import datetime
from mx import DateTime
datetime = DateTime

from utilities import kante, punkt
from derivedTables import DbDiagramm
#Dialogs
from SaveDialog import SaveDialog

# schleifen beschleunigen
try:
    from psyco.classes import __metaclass__
except:
    pass

import Projection

from time import sleep
from wxPython.wx import *

from thread import *
#import system

class DiagrammZerleger:
	def __init__(self,dbfact,kanten,gruppenid,typ,title,main_window):
		self.dbfact= dbfact
		self.kantenfeld=kanten
		self.gruppenid=gruppenid
		self.voropresent = False
		self.delaunaypresent = False
		self.typ = typ
		self.ready=False
		self.dbDiagrammList=[]
		self.title=title
		self.percent = 0
		self.fertig=False
		self.wxparent=main_window
		# hole vorhandenen Diagramme zu dieser Gruppe ( max 2: 1 Voronoi 1 Delaunay )
		
		
		diagramme = self.dbfact.dbDiagrammFromGruppe(gruppenid)
		if diagramme == None:
			return
		if len(diagramme) ==0:
			print "Keine Diagramme vorhanden"
			
		else:
			i=diagramme[0]
			if i.typ=="Voronoi" :
				self.voropresent = True
			if i.typ=="Delaunay":
				self.delaunaypresent = True
		if self.typ == "Voronoi" and self.voropresent:
			print "Diagramm ist vorhanden"
			self.ready=True
		elif self.typ == "Delaunay" and self.delaunaypresent:
			print "Diagramm ist vorhanden"
			self.ready=True
		
			
		if not self.ready :
			if self.typ=="Voronoi":
				progressBar = wxProgressDialog("Bitte warten", "DBDiagramm wird erstellt", 100, self.wxparent, wxPD_AUTO_HIDE)
				threadfunc = self._prepareVoronoi
				identifier = start_new_thread(threadfunc,tuple())
				while not self.Fertig():
					sleep(0.1)
					progressBar.Update( int(self.Percent()) )
					progressBar.Update( 100 )
				self.fertig=False
				self.percent = 0
				progressBar.Destroy()
				
				#self.dbDiagrammList=self._prepareVoronoi()
			if self.typ=="Delaunay":
				progressBar = wxProgressDialog("Bitte warten", "DBDiagramm wird erstellt", 100, self.wxparent, wxPD_AUTO_HIDE)
				threadfunc = self._prepareDelaunay
				identifier = start_new_thread(threadfunc,tuple())
				while not self.Fertig():
					sleep(0.1)
					progressBar.Update( int(self.Percent()) )
					progressBar.Update( 100 )
				self.fertig=False
				self.percent = 0
				progressBar.Destroy()
				#self.dbDiagrammList=self._prepareDelaunay()
	
	def _GeomSQL(self,x1,y1,x2,y2):
		#baue sowas "SRID=-1;LINESTRING(x1 y1, x2 y2)"
		#print "Anfang :%r %r"%(anfangpkt.x(),anfangpkt.y())
		#print "Ende :%r %r"%(endpkt.x(),endpkt.y())
	
		sqlstring = "SRID=-1;LINESTRING(%s %s,%s %s)" %(x1,y1,x2,y2)
		return sqlstring
		
	def _prepareVoronoi(self):
		liste=[]
		length = len(self.kantenfeld)
		counter = 0
		for k in self.kantenfeld:
			counter += 1
			pktR=k.datenPunktRechts
			pktL=k.datenPunktLinks
			x1 = k.orig_xanfang
			y1=k.orig_yanfang
			x2=k.orig_xende
			y2=k.orig_yende
			endpkt= k.endpunkt
			geom = self._GeomSQL(x1,y1,x2,y2)
			diagrammRow = DbDiagramm(db=self.dbfact.db,logger=self.dbfact.logger,
						  name=self.title,typ="Voronoi",geomkante=geom,
						  pktrechts=pktR,pktlinks=pktL,gruppenid=self.gruppenid)
			liste.append(diagrammRow)
			self.percent=(99/length)*counter
		self.dbDiagrammList=liste
		self.fertig=True
	
	def _prepareDelaunay(self):
		liste=[]
		length = len(self.kantenfeld)
		counter = 0
		for k in self.kantenfeld:
			counter += 1
			pktR=k.datenPunktRechts
			pktL=k.datenPunktLinks
			x1 = k.orig_xanfang
			y1=k.orig_yanfang
			x2=k.orig_xende
			y2=k.orig_yende
			geom = self._GeomSQL(x1,y1,x2,y2)
			diagrammRow = DbDiagramm(db=self.dbfact.db,logger=self.dbfact.logger,
						  name=self.title,typ="Delaunay",geomkante=geom,
						  pktrechts=pktR,pktlinks=pktL,gruppenid=self.gruppenid)
			liste.append(diagrammRow)
			self.percent=(99/length)*counter
		self.dbDiagrammList=liste
		self.fertig=True

					 
	def save(self):
		progressBar = wxProgressDialog("Bitte warten", "DBDiagramm wird gespeichert...", 100, self.wxparent, wxPD_AUTO_HIDE)
		threadfunc = self._save
		self.fertig=False
		identifier = start_new_thread(threadfunc,tuple())
		while not self.Fertig():
			sleep(0.1)
			progressBar.Update( int(self.Percent()) )
		progressBar.Update( 100 )
		self.fertig=False
		self.percent = 0
		progressBar.Destroy()
		self._debugKantenfeld()
		
			
	def _save(self):
		length = len(self.dbDiagrammList)
		counter=0
		for object in self.dbDiagrammList:
			counter += 1
			self.percent=(99.9/length)*counter
			object.save()
		
		self.dbfact.db.commit()
		self.fertig=True
		
	
	def _debugKantenfeld(self,filename="/home/bernd/delaunay_db.txt"):
		f=open(filename,"w")
		for i in self.kantenfeld:
			f.write("%s\n"%i)
		f.close()
		
	def Fertig(self):
		return self.fertig
	def Percent(self):
		return self.percent
	



class ShapeStoreZerleger:
	
	def __init__(self,dbfact,StorageObject,wxparent):
		self.dbfact=dbfact
		self.StorageObject=StorageObject
		self.tiefen=[]
		self.wxparent = wxparent
		
		

	def Fertig(self):
		return self.fertig
	
	def Percent(self):
		return self.percent
	

	def RunDialog(self,name,args):
		evalstring = "%s(self.wxparent,args)"%name
		dlg = eval(evalstring)
		return dlg.RunDialog()


		
	

			
	def saveShapeFile(self):
		#what to do
		# 1. biuld OGC conform convexHull from shapfile
		# 2. lookupdb for convexHull and for disjunction of it
		# 3. build schlag
		# 4. lookupdb for tiefen
		# 5. fire tiefendialog
		self.fertig=False
		self.percent = 0
		
		dlg = SaveDialog(self.wxparent,self.StorageObject )
		result = dlg.RunDialog()
		if result==None:
			return False

		theRootGeom,gruppe,schlag = result
		self.theRootGeom = theRootGeom
		self.gruppe=gruppe
		self.schlag=schlag
		return True
					


					
		
		
		
		
	
	
