from wxPython.wx import *
from wxPython.grid import *
from Thuban import _

class allgTabellenAnzeige(wxDialog):

    def __init__( self, parent, werte, zeilenNamen, spaltenNamen, titel, tool=None ):
        """
        werte - matrix mit werte[zeile][spalte]
        """
        wxDialog.__init__(self, parent, -1, _(titel),style=wxMINIMIZE_BOX|wxHSCROLL|wxVSCROLL|wxCAPTION)
        # Create a wxGrid object
        self.parent = parent
        
        self.tool = None
        
        if tool != None:
            self.tool = tool

        hoehe = 50 + len(zeilenNamen) * 20
        if hoehe > 300:
            hoehe = 300
        self.grid = wxGrid( self,
                           -1,
                           wxPoint( 0, 0 ),
                           wxSize( 300, hoehe ) )
    
        top = wxBoxSizer(wxVERTICAL)
        
        
        self.grid.CreateGrid( len(zeilenNamen), len(spaltenNamen) )
        
        for i in range( len(werte)):
            aktuelleZeile = werte[i]
            #self.grid.SetCellValue(i, 0, alleKeys[i])
            for j in range( len(aktuelleZeile) ):
                self.grid.SetCellValue(i, j, str(aktuelleZeile[j]) )

       
        for i in range( len( spaltenNamen ) ):
            self.grid.SetColLabelValue( i, spaltenNamen[i] )
            
        for i in range( len( zeilenNamen )):
            self.grid.SetRowLabelValue( i, zeilenNamen[i] )

        self.grid.SetRowLabelSize( 150 )
            
        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(self.grid, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)
        
        buttons = wxBoxSizer(wxHORIZONTAL)
        button = wxButton(self, wxID_OK, _("OK"))
        buttons.Add(button, 0, wxALL, 4)
        top.Add(buttons, 0, wxALIGN_RIGHT, 4)

        self.SetAutoLayout(1)
        self.SetSizer(top)
        top.Fit(self)
        top.SetSizeHints(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)
        
        
    def RunDialog(self):
        self.Show(True)
        return

    def end_dialog(self):
        if self.tool != None:
            self.tool.abraeumen()
        self.Show(False)
        self.Destroy()

    def OnOK(self, event):
        self.end_dialog()

# ------------------------------------------------------------------------------------------

class tabellenAnzeige(wxDialog):

    def __init__( self, parent, auswertungsResultat, titel, punktefeld, tool ):
        wxDialog.__init__(self, parent, -1, _(titel), style=wxMINIMIZE_BOX|wxHSCROLL|wxVSCROLL|wxCAPTION)
        # Create a wxGrid object
        self.parent = parent
        self.punktefeld = punktefeld
        self.tool = tool
        self.layer = self.tool.layer
        self.grid = wxGrid( self,
                           -1,
                           wxPoint( 0, 0 ),
                           wxSize( 600, 300 ) )
    
        top = wxBoxSizer(wxVERTICAL)
        
        alleKeys = auswertungsResultat.keys()
        
        self.grid.CreateGrid( len(alleKeys), 6 )
        
        for i in range( len(alleKeys)):
            aktuelleZeile = auswertungsResultat[alleKeys[i]]
            #self.grid.SetCellValue(i, 0, alleKeys[i])
            for j in range( len(aktuelleZeile) ):
                self.grid.SetCellValue(i, j, str(aktuelleZeile[j]) )
                if j == 0:
                    self.grid.SetCellBackgroundColour( i, j, wxColour( 100, 100, 200 ) )
                elif j == 2:
                    self.grid.SetCellBackgroundColour( i, j, wxColour( 200, 100, 100 ) )
        self.grid.SetColFormatFloat(0, 6, 4);
        self.grid.SetColFormatFloat(1, 6, 4);
        self.grid.SetColFormatFloat(2, 6, 4);
        self.grid.SetColFormatFloat(3, 6, 4);
        
        colLabels = [ _("min. Wert"), _("Mittelwert"), _("max. Wert"), _("Std. Abw."), _("ID (min.)"), _("ID (max.)") ]
        
        for i in range( len( colLabels ) ):
            self.grid.SetColLabelValue( i, colLabels[i] )
            
        for i in range( len( alleKeys )):
            self.grid.SetRowLabelValue( i, alleKeys[i] )

        self.grid.SetRowLabelSize( 100 )
            
        box = wxBoxSizer(wxHORIZONTAL)
        box.Add(self.grid, 1, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
        top.Add(box, 0, wxEXPAND)
        
        buttons = wxBoxSizer(wxHORIZONTAL)
        button = wxButton(self, wxID_OK, _("OK"))
        buttons.Add(button, 0, wxALL, 4)
        top.Add(buttons, 0, wxALIGN_RIGHT, 4)

        self.SetAutoLayout(1)
        self.SetSizer(top)
        top.Fit(self)
        top.SetSizeHints(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)
        
        EVT_GRID_CELL_LEFT_CLICK( self, self.zelleGeklickt )
    
    def zelleGeklickt( self, gridEvent ):
        col = gridEvent.GetCol()
        row = gridEvent.GetRow()
        
        if col >= 4:
            gid = int(self.grid.GetCellValue( row, col ))
            
            x, y = (None,None)
            for i in self.punktefeld:
                if i.index == gid:
                    x = i.x()
                    y = i.y()
                    break
            if x == None:
                return
            
            winX, winY = self.tool.view.proj_to_win(x,y)
            
            self.tool.view.SelectShapeAt( winX, winY )
            
            
        
    def RunDialog(self):
        self.Show(True)
        return

    def end_dialog(self):
        self.Show(False)
        self.tool.map.RemoveLayer( self.layer )
        self.Destroy()

    def OnOK(self, event):
        self.end_dialog()
