from Thuban.UI.viewport import Tool, RectTool
import os
from Thuban import _
from Thuban.UI.command import registry, ToolCommand
from wxPython.wx import *
from Thuban.UI.mainwindow import *
from Thuban.Model.data import *
from Thuban.Model.table import MemoryTable, \
     FIELDTYPE_DOUBLE, FIELDTYPE_INT, FIELDTYPE_STRING
     
#from diagrammDialog import attributAuswahl
from tabellenAnzeige import *

from data_fake import *
from shapeStoreVorbereiter import *

from customLayer import customLayer

# schleifen beschleunigen
try:
    from psyco.classes import __metaclass__
except:
    pass

# ----------------------------------------------------------

class TeilschlagTool(RectTool):

    def __init__(self, view, context, findePunktLayer):
        RectTool.__init__(self, view)
        self.context = context
        self.startX = 0
        self.startY = 0
        
        self.map = self.context.mainwindow.canvas.Map()
        self.layer = None
        
        self._findePunktLayer = findePunktLayer
        
    def Name(self):
        return "TeilschlagWerkzeug"

    def MouseDown(self, event):
        RectTool.MouseDown(self, event)
        self.startX, self.startY = self.view.win_to_proj(*self.current)

    def MouseUp(self, event):
        RectTool.MouseUp(self, event)
        x, y = self.view.win_to_proj(*self.current)
        bbox = ( min(x,self.startX), min(y,self.startY), max(x,self.startX), max(y,self.startY) )

        main_window = self.context.mainwindow
        map = main_window.canvas.Map()

        if map.HasLayers() == True:
            layerMitPunktdaten = self._findePunktLayer(self.context)
    
            if layerMitPunktdaten < 0:
                main_window.RunMessageBox(_('missing base data layer'), _('Please add a layer consisting of point data, first'))
                return
            
            punkteShapefeld = map.layers[layerMitPunktdaten].ShapesInRegion(bbox)
            
            punktefeld = []
            genaueBbox = [ bbox[2], bbox[3], bbox[0], bbox[1] ]
            minGID = 100000000
            maxGID = 0
            for i in punkteShapefeld:
                Px, Py = i.Points()[0][0]
                # Thuban ist zu ungenau, zweites filtern noetig
                if Px >= bbox[0] and Px <= bbox[2] and Py >= bbox[1] and Py <= bbox[3]:
                    if Px > genaueBbox[2]:
                        genaueBbox[2] = Px
                    if Px < genaueBbox[0]:
                        genaueBbox[0] = Px
                    if Py > genaueBbox[3]:
                        genaueBbox[3] = Py
                    if Py < genaueBbox[1]:
                        genaueBbox[1] = Py
                    punktefeld.append( punkt( [Px, Py], i.ShapeID() ) )
                    
                    if i.ShapeID() < minGID:
                        minGID = i.ShapeID()
                    if i.ShapeID() > maxGID:
                        maxGID = i.ShapeID()
            
            if len( punktefeld ) <= 0:
                print "- keine Punkte im gewaehlten Bereich"
                main_window.RunMessageBox(_('keine Punkte'), _('Keine Punkte im gewaehlten Bereich'))
                return
            
            storageObjekt = MemoryShapeStore()
            storageObjekt.bbox = genaueBbox
            
            storageObjekt.setTable( MemoryTable([("Bezeichnung", FIELDTYPE_STRING)],[]) )
            
            # obere Linie
            storageObjekt.addLine( [genaueBbox[0], genaueBbox[2]], [genaueBbox[3],genaueBbox[3]] )
            storageObjekt.appendAttributeData( ["oben"] )
            # rechte Linie
            storageObjekt.addLine( [genaueBbox[2], genaueBbox[2]], [genaueBbox[1],genaueBbox[3]] )
            storageObjekt.appendAttributeData( ["rechts"] )
            # untere Linie
            storageObjekt.addLine( [genaueBbox[0], genaueBbox[2]], [genaueBbox[1],genaueBbox[1]] )
            storageObjekt.appendAttributeData( ["unten"] )
            # linke Linie
            storageObjekt.addLine( [genaueBbox[0], genaueBbox[0]], [genaueBbox[1],genaueBbox[3]] )
            storageObjekt.appendAttributeData( ["links"] )
            
            
            storeVorbereiter = shapeStoreVorbereiter( map.layers[layerMitPunktdaten].ShapeStore(), storageObjekt )
            storeVorbereiter.setztePunkteFeld( punktefeld, genaueBbox, False )
            titel = "Teilschlg. ID"+ str(minGID) + "-" + str(maxGID)+ "," + repr(genaueBbox[0])[:6]+" "+repr(genaueBbox[1])[:6]+" "+repr(genaueBbox[2])[:6]+" "+repr(genaueBbox[3])[:6]
    
            auswertung = storeVorbereiter.statistischeAuswertung()
    
            self.layer = customLayer( _(titel), storageObjekt)
            storageObjekt.setTitle( titel )

            self.map.AddLayer(self.layer)
            self.context.session.AddShapeStore( storageObjekt )
            self.map.MoveLayerToBottom(self.layer)
            self.context.mainwindow.canvas.full_redraw()
            
            tabelle = tabellenAnzeige( main_window, auswertung, titel, storeVorbereiter.getRohPunktefeld(), self )
            tabelle.RunDialog()
        
       
