from Thuban.UI.viewport import Tool, RectTool
import os
from Thuban import _
from Thuban.UI.command import registry, ToolCommand
from wxPython.wx import *
from Thuban.UI.mainwindow import *
from Thuban.Model.data import *
from Thuban.Model.table import MemoryTable, \
     FIELDTYPE_DOUBLE, FIELDTYPE_INT, FIELDTYPE_STRING
     
from diagrammDialog import attributAuswahl
from tabellenAnzeige import *

from data_fake import *
from shapeStoreVorbereiter import *

from statTests import *
from customLayer import customLayer

# schleifen beschleunigen
try:
    from psyco.classes import __metaclass__
except:
    pass
# ----------------------------------------------------------

class VarianzAnalysenTool(RectTool):

    def __init__(self, view, context, findePunkteLayer):
        RectTool.__init__(self, view)
        self.context = context
        self.startX = 0
        self.startY = 0
        
        self._findePunktLayer = findePunkteLayer
        
        self.map = self.context.mainwindow.canvas.Map()
        self.main_window = self.context.mainwindow
        self.layers = []
        
        self.werte = []
        self.attribute = []
        self.k = 0
        
    def Name(self):
        return "VarianzAnalyse"

    def MouseDown(self, event):
        RectTool.MouseDown(self, event)
        self.startX, self.startY = self.view.win_to_proj(*self.current)

    def MouseUp(self, event):
        RectTool.MouseUp(self, event)
        x, y = self.view.win_to_proj(*self.current)
        bbox = ( min(x,self.startX), min(y,self.startY), max(x,self.startX), max(y,self.startY) )

        #main_window = self.context.mainwindow

        if self.map.HasLayers() == True:
            layerMitPunktdaten = self._findePunktLayer(self.context)
    
            if layerMitPunktdaten < 0:
                self.main_window.RunMessageBox(_('missing base data layer'), _('Please add a layer consisting of point data, first'))
                return

            attrTable = self.map.layers[layerMitPunktdaten].ShapeStore().Table()
            cols = self.map.layers[layerMitPunktdaten].ShapeStore().Table().Columns()
            colNames = []
            
            for i in cols:
                if i.type == FIELDTYPE_INT or i.type == FIELDTYPE_DOUBLE:
                    colNames.append( i.name )
                
            diagram_titel = _("Angaben zur Varianzanalyse")
    
            v_dialog = attributAuswahl( self.main_window, colNames, diagram_titel )
            userEingabe = v_dialog.RunDialog()
            if userEingabe == None:
                self.abraeumen()
                return
            
            while attrTable.HasColumn( userEingabe["attr"] )==False:
                v_dialog = attributAuswahl( self.main_window, colNames, diagram_titel, _("das Attribut existiert nicht") )
                userEingabe = v_dialog.RunDialog()
                if userEingabe == None:
                    self.abraeumen()
                    return
            
            punkteShapefeld = self.map.layers[layerMitPunktdaten].ShapesInRegion(bbox)
            
            punktefeld = []
            genaueBbox = [ bbox[2], bbox[3], bbox[0], bbox[1] ]

            for i in punkteShapefeld:
                Px, Py = i.Points()[0][0]
                # Thuban ist zu ungenau, zweites filtern noetig
                if Px >= bbox[0] and Px <= bbox[2] and Py >= bbox[1] and Py <= bbox[3]:
                    if Px > genaueBbox[2]:
                        genaueBbox[2] = Px
                    if Px < genaueBbox[0]:
                        genaueBbox[0] = Px
                    if Py > genaueBbox[3]:
                        genaueBbox[3] = Py
                    if Py < genaueBbox[1]:
                        genaueBbox[1] = Py
                    punktefeld.append( punkt( [Px, Py], i.ShapeID() ) )
            
            if len( punktefeld ) <= 0:
                print "- keine Punkte im gewaehlten Bereich"
                self.main_window.RunMessageBox(_('keine Punkte'), _('Keine Punkte im gewaehlten Bereich'))
                return
            
            storageObjekt = MemoryShapeStore()
            storageObjekt.bbox = genaueBbox
            
            storageObjekt.setTable( MemoryTable([("Bezeichnung", FIELDTYPE_STRING)],[]) )
            
            # obere Linie
            storageObjekt.addLine( [genaueBbox[0], genaueBbox[2]], [genaueBbox[3],genaueBbox[3]] )
            storageObjekt.appendAttributeData( ["oben"] )
            # rechte Linie
            storageObjekt.addLine( [genaueBbox[2], genaueBbox[2]], [genaueBbox[1],genaueBbox[3]] )
            storageObjekt.appendAttributeData( ["rechts"] )
            # untere Linie
            storageObjekt.addLine( [genaueBbox[0], genaueBbox[2]], [genaueBbox[1],genaueBbox[1]] )
            storageObjekt.appendAttributeData( ["unten"] )
            # linke Linie
            storageObjekt.addLine( [genaueBbox[0], genaueBbox[0]], [genaueBbox[1],genaueBbox[3]] )
            storageObjekt.appendAttributeData( ["links"] )
            
            storeVorbereiter = shapeStoreVorbereiter( self.map.layers[layerMitPunktdaten].ShapeStore(), storageObjekt )
            storeVorbereiter.setztePunkteFeld( punktefeld, genaueBbox, False )
            
            titel = "Varianzanal. "+userEingabe["attr"]+", "+str(self.k)
            self.k += 1
    
            aktLayer = customLayer( _(titel), storageObjekt)
            storageObjekt.setTitle( titel )
            
            self.layers.append( aktLayer )

            self.map.AddLayer(aktLayer)
            self.context.session.AddShapeStore( storageObjekt )
            self.context.mainwindow.canvas.full_redraw()
            
            self._fuegeWerteHinzu( punktefeld, attrTable, userEingabe["attr"] )
            
            if len(self.werte) > 1:
                dialog = signifikanzDialog( self.main_window, _("Fertig?") )
                ergebnis = dialog.RunDialog()
            else:
                return
            
            if ergebnis == None:
                dialog = signifikanzDialog( self.main_window, _("Sigifikanz angeben"), "Bitte geben Sie die Signifikanz an!" )
                ergebnis = dialog.RunDialog()
                
                while ergebnis == None or ergebnis["numKath"].isdigit() == False:
                    if ergebnis == None:
                        self.abraeumen()
                        return
                    dialog = signifikanzDialog( self.main_window, _("Sigifikanz angeben"), "Bitte geben Sie die Signifikanz an!" )
                    ergebnis = dialog.RunDialog()
                    
                alpha = float(ergebnis["numKath"])
                # abfangen, falls alpha keine zahl ist
                alpha /= 100
                
                if len( self.werte ) <= 1:
                    self.main_window.RunMessageBox(_('zu wenig Stichproben'), _('Fuer die Varianzanalyse werden mindestens 2 Stichproben benoetigt.'))
                    self.abraeumen()
                    return
                    
                self._varianzAnalyse( alpha )


    def _fuegeWerteHinzu( self, punktefeld, attrTable, attribut ):
    
        self.attribute.append( attribut )
        
        ind = len( self.werte )
        self.werte.append([])
            
        for i in range( len(punktefeld) ):
            self.werte[ind].append( attrTable.ReadValue( punktefeld[i].index, attribut ) )
        

    def _varianzAnalyse( self, alpha ):
        varianzAnalyse = VarianzAnalyse( self.werte )

        D = varianzAnalyse.getPruefsumme()
        wahrsch = varianzAnalyse.signifikanzZurPruefsumme()
        print "D:", D, ", Wahrscheinlichk.", wahrsch
        print "freiheitsgrade:", varianzAnalyse.getXYFreiheitsgrade()
        
                
        attribut_string = str( self.attribute )
        
        if varianzAnalyse.fehlerIstAufgetreten():
            self.main_window.RunMessageBox(_('Fehler'), _('Es ist folgender Fehler aufgetreten:\n'+str(VarianzAnalyse.getFehler())))
            return
            
        gleichheitWiderlegt = "nein"
        if (varianzAnalyse.signifikanzZurPruefsumme() <= alpha):
            gleichheitWiderlegt = "ja"
            
        anzeiger = allgTabellenAnzeige( self.main_window, [[ alpha ],[ str(round(varianzAnalyse.getPruefsumme(),5))[:8] ], [str(round(varianzAnalyse.signifikanzZurPruefsumme(),5))[:8]], [str(varianzAnalyse.getXYFreiheitsgrade())], [gleichheitWiderlegt ]], [ "Signifikanz", "Pruefsumme T(n)", "P(T(n)>f)", "Freiheitsgrade", "Gleichh.d.Var. widerlegt" ], ["wert"], "Varianz Analyse", tool=self )
        anzeiger.RunDialog()
        
    def abraeumen( self ):
        self.k = 0
        del self.werte
        self.werte = []
        for i in self.layers:
            self.map.RemoveLayer( i )
            
        del self.layers
        self.layers = []


# ---------------------------------------------------------------


class signifikanzDialog( wxDialog ):
    def __init__(self, parent, titel, message = ""):
        wxDialog.__init__(self, parent, -1, titel)

        self.mitRueckgabe = False
        
        top = wxBoxSizer(wxVERTICAL)
        

        if message:
            self.mitRueckgabe = True
            top.Add(wxStaticText(self, -1, message), 0,
                    wxALL|wxALIGN_CENTER_VERTICAL, 4)

            box = wxBoxSizer(wxHORIZONTAL)
            box.Add(wxStaticText(self, -1, _("Signifikanz (%):")), 0,
                    wxALL|wxALIGN_CENTER_VERTICAL, 4)
            self.text_numKath = wxTextCtrl(self, -1)
        
            box.Add(self.text_numKath, 2, wxALL|wxALIGN_CENTER_VERTICAL|wxEXPAND, 4)
            top.Add(box, 0, wxEXPAND)
        else:
            top.Add(wxStaticText(self, -1, _("Wollen Sie eine weitere Partition hinzufuegen?")), 0,
                    wxALL|wxALIGN_CENTER_VERTICAL, 4)


        buttons = wxBoxSizer(wxHORIZONTAL)
        if self.mitRueckgabe != True:
            button = wxButton(self, wxID_OK, _("Ja"))
        else:
            button = wxButton(self, wxID_OK, _("OK"))
        buttons.Add(button, 0, wxALL, 4)
        if self.mitRueckgabe != True:
            button = wxButton(self, wxID_CANCEL, _("Nein"))
        else:
            button = wxButton(self, wxID_CANCEL, _("Cancel"))
        buttons.Add(button, 0, wxALL, 4)
        top.Add(buttons, 0, wxALIGN_RIGHT, 4)

        self.SetAutoLayout(1)
        self.SetSizer(top)
        top.Fit(self)
        top.SetSizeHints(self)

        EVT_BUTTON(self, wxID_OK, self.OnOK)
        EVT_BUTTON(self, wxID_CANCEL, self.OnCancel)

    def RunDialog(self):
        self.ShowModal()
        self.Destroy()
        return self.result

    def end_dialog(self, result):
        self.result = result
        if result is not None:
            self.EndModal(wxID_OK)
        else:
            self.EndModal(wxID_CANCEL)
        self.Show(False)

    def OnOK(self, event):
        if self.mitRueckgabe == True:
            result = {}
            result["numKath"] = getattr(self, "text_numKath").GetValue()
        else:
            result = {}
        self.end_dialog(result)

    def OnCancel(self, event):
        self.end_dialog(None)
