-- Skript zum Anlegen der Datanbankstruktur fr das GIS
--
--
-- 1. Loeschen der alten Relationen falls existent incl. entfernen der geometrischen Attribute
-- 2. Anlegen der Realtionen incl gemometrischen Attribute
-- 3. Anlegen der Integittsregeln mittels plpgsql Funktionen





-- 1. Loeschen
select DropGeometryColumn('','diagramm','geom_kante');
--select DropGeometryColumn('','diagramm','geom_pktlinks');
--select DropGeometryColumn('','diagramm','geom_pktrechts');
drop table Diagramm;

select DropGeometryColumn('','geompoint','geom');
drop table geompoint ;

select DropGeometryColumn('','geompoly','geom');
drop table geompoly ;

select DropGeometryColumn('','geommultilinestring','geom');
drop table geomMultiLineString ;

select DropGeometryColumn('','geommultipoly','geom');
drop table geomMultipoly ;

drop table geom cascade ;

drop table Gruppe;

drop table Attribut;

drop table Attribut_typ;

drop table raster ;

drop table AttributListe;

drop table Tiefe;

drop table idtable;

select DropGeometryColumn('','schlag','geomBorderPoly');
select DropGeometryColumn('','schlag','geomborderpoly');
drop table Schlag;



--- idTable

create Table idtable 
(
"tablename" varchar not null,
"nextnumber" int not null,
constraint "PK_idtable" Primary Key("tablename")
);

insert into idtable values ('schlag',1);
insert into idtable values ('tiefe',1);
insert into idtable values ('raster',1);
insert into idtable values ('attribut_typ',1);
insert into idtable values ('diagramm',1);
insert into idtable values ('gruppe',1);
insert into idtable values ('geom',1);


--
-- Table Schlag
--

CREATE TABLE Schlag
(
"schlag_id" int NOT NULL,
"name" varchar(100) NOT NULL,
"datum" timestamp not NULL,
"parent" int ,
"root" int,
    CONSTRAINT "PK_Schlag" PRIMARY KEY ("schlag_id")
);
select AddGeometryColumn('','schlag','geomborderpoly','-1','POLYGON',2);


------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--
-- Table Tiefe
---


CREATE TABLE Tiefe
(
"tiefe" int,
"tiefen_id" int NOT NULL,
"schlag_id" int NOT NULL,
  CONSTRAINT "PK_Tiefe" PRIMARY KEY ("tiefen_id", "schlag_id")
);


----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--
-- Table Geom
--


CREATE TABLE Geom
(
"schlag_id" int NOT NULL,
"geom_id" int NOT NULL,
"shape_id" int NOT NULL,
"parent" int,
"root" int,
  CONSTRAINT "PK_Geom" PRIMARY KEY ("geom_id")
);


----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--
-- Table GeomPoint
--


CREATE TABLE GeomPoint
(
"temp" int
) inherits (GEOM);
select AddGeometryColumn('','geompoint','geom','-1','POINT',3);
alter table geompoint drop column temp;


----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--
-- Table GeomPoly
--



CREATE TABLE GeomPoly
(
"temp" int
) inherits (GEOM);
select AddGeometryColumn('','geompoly','geom','-1','POLYGON',3);
alter table GeomPoly drop column temp;


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--
-- Talbe GeomMultiLineString
--



CREATE TABLE GeomMultiLineString
(
"temp" int
) inherits (GEOM);
select AddGeometryColumn('','geommultilinestring','geom','-1','MULTILINESTRING',3);
alter table GeomMultiLineString drop column temp;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--
-- Table GeomMultiPoly
--



CREATE TABLE GeomMultiPoly
(
"temp" int
) inherits (GEOM);
select AddGeometryColumn('','geommultipoly','geom','-1','MULTIPOLYGON',3);
alter table GeomMultiPoly drop column temp;


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--
-- Table AttributListe
--


CREATE TABLE AttributListe
(
"tiefen_id" int NOT NULL,
"schlag_id" int NOT NULL,
"name" varchar,
"description" varchar,
  CONSTRAINT "PK_AttributListe" PRIMARY KEY ("tiefen_id", "schlag_id")
);


----------------------------------------------------------------------------------------------
--
-- Table Attribut_typ
--


CREATE TABLE Attribut_typ
(
"tiefen_id" int NOT NULL,
"atttyp_id" int NOT NULL,
"schlag_id" int NOT NULL,
"raster_id" int ,
"datatype"  varchar NOT NULL,
"type" varchar,
  CONSTRAINT "PK_Attribut_typ" PRIMARY KEY ("atttyp_id","tiefen_id","schlag_id")
);


----------------------------------------------------------------------------------------------
--
-- Table raster
--



CREATE TABLE raster
(
"raster_id" int NOT NULL,
"einheit" varchar,
"x_space" int,
"y_space" int,
  CONSTRAINT "PK_raster" PRIMARY KEY ("raster_id")
);


----------------------------------------------------------------------------------------------
--
-- Table Attribut
--


CREATE TABLE Attribut
(
"value" varchar,
"atttyp_id" int NOT NULL,
"tiefen_id" int NOT NULL,
"schlag_id" int NOT NULL,
"geom_id" int NOT NULL,
  CONSTRAINT "PK_Attribut" PRIMARY KEY ("atttyp_id","geom_id","tiefen_id","schlag_id")
);


----------------------------------------------------------------------------------------------
--
-- Table Gruppe
--

create table Gruppe
(
"gruppen_id" int NOT NULL,
"geom_id" int NOT NULL,
"datum" timestamp NOT NULL,
"name" varchar,
"beschreibung" varchar,
  CONSTRAINT "PK_Gruppe" Primary Key ("gruppen_id")
);




-----------------------------------------------------------------------------------------------
--
-- Table Diagramm
--
create table Diagramm
(
"diagramm_id" int not null,
"gruppen_id" int not null,
"pktrechts" int,
"pktlinks" int,
"name" varchar,
"typ" varchar not null,
  CONSTRAINT "PK_Diagramm" Primary Key("diagramm_id")
);
select AddGeometryColumn('','diagramm','geom_kante','-1','LINESTRING',3);
--select AddGeometryColumn('','diagramm','geom_pktlinks','-1','LINESTRING',3);
--select AddGeometryColumn('','diagramm','geom_pktrechts','-1','LINESTRING',3);

--------------------------------------------------------------------------------------------------
--
-- Es folgen Integrittsregeln wie Foreign Key beziehungen zwischen den Relationen







--------------------------------------------------------------------------------------------------
--
--
-- Parentbeziehung in Schlag
--
ALTER TABLE Schlag add Constraint "parent" FOREIGN KEY (
"parent"
)
REFERENCES Schlag (
"schlag_id"
);


-------------------------------------------------------------------------------------------------
--
-- Foreign Key in Tiefe (von Schlag)
--


ALTER TABLE Tiefe ADD CONSTRAINT "fk_schlag" FOREIGN KEY (
"schlag_id"
)
REFERENCES Schlag (
"schlag_id"
);


-------------------------------------------------------------------------------------------------
--
-- Foreign Key in AttributListe (von Tiefe)
--


ALTER TABLE AttributListe ADD CONSTRAINT "fk_tiefe" FOREIGN KEY (
"tiefen_id",
"schlag_id"
)
REFERENCES Tiefe (
"tiefen_id",
"schlag_id"
);


-------------------------------------------------------------------------------------------------
--
-- Foreign Key in Attribut_typ (von AttributListe)
--

ALTER TABLE Attribut_typ ADD CONSTRAINT "fk_attributliste" FOREIGN KEY (
"tiefen_id",
"schlag_id"
)
REFERENCES AttributListe (
"tiefen_id",
"schlag_id"
);

-------------------------------------------------------------------------------------------------
--
-- Foreign Key in Attribut_typ (von Raster)
--

ALTER TABLE Attribut_typ ADD CONSTRAINT "fk_raster" FOREIGN KEY (
"raster_id"
)
REFERENCES Raster (
"raster_id"
);


-------------------------------------------------------------------------------------------------
--
-- Foreign Key in Attribut (von Attribut_typ)
--


ALTER TABLE Attribut ADD CONSTRAINT "fk_attribut_typ" FOREIGN KEY (
"atttyp_id",
"tiefen_id",
"schlag_id"
)
REFERENCES Attribut_typ (
"atttyp_id",
"tiefen_id",
"schlag_id"
);

-------------------------------------------------------------------------------------------------
--
-- Foreign Key in Attribut (von geom)
--

--ALTER TABLE Attribut ADD CONSTRAINT "fk_geom" FOREIGN KEY (
--"geom_id"
--)
--REFERENCES Geom (
--"geom_id"
--);




-------------------------------------------------------------------------------------------------
--
-- Parent beziehung in Geom
--


ALTER TABLE Geom ADD CONSTRAINT "parent" FOREIGN KEY (
"parent"
)
REFERENCES Geom (
"geom_id"
);



-------------------------------------------------------------------------------------------------
--
-- Foreign Key in Geom (von Schlag)
--


ALTER TABLE Geom ADD CONSTRAINT "fk_schlag" FOREIGN KEY (
"schlag_id"
)
REFERENCES Schlag (
"schlag_id"
);


-------------------------------------------------------------------------------------------------
--
-- Foreign Key in Gruppe (von geom)
--


--ALTER TABLE Gruppe ADD CONSTRAINT "fk_geom" FOREIGN KEY (
--"geom_id"
--)
--REFERENCES Geom (
--"geom_id"
--);


-------------------------------------------------------------------------------------------------
--
-- Foreign Key in Diagramm (von gruppe)
--


ALTER TABLE Diagramm ADD CONSTRAINT "fk_gruppe" FOREIGN KEY (
"gruppen_id"
)
REFERENCES Gruppe (
"gruppen_id"
);




create or replace function checkforgeom() returns trigger as '


DECLARE
	id int;
BEGIN
	select into id geom_id from geom where geom_id=NEW.geom_id;
	if NOT FOUND then
		return OLD;
	else
		return NEW;
	end if;
END;
' LANGUAGE plpgsql;

DROP Trigger checkgeomtrig on gruppe;
CREATE TRIGGER checkgeomtrig BEFORE INSERT OR UPDATE ON gruppe
    FOR EACH ROW EXECUTE PROCEDURE checkforgeom();

DROP Trigger checkgeomtrig on attribut;
CREATE TRIGGER checkgeomtrig BEFORE INSERT OR UPDATE ON attribut
    FOR EACH ROW EXECUTE PROCEDURE checkforgeom();


create or replace function getnextid(varchar) returns int as'
DECLARE
	thetable alias for $1;
	query text;
	id int;
BEGIN
	select into id nextnumber from idtable where tablename=thetable for update;
	query := ''update idtable set nextnumber=nextnumber+1 where tablename='' ||quote_literal(thetable);
	execute query;
	return id;
END;
' LANGUAGE plpgsql;
